{ **************************************************************************** }
{ *                                                                          * }
{ * CRAZY CHEWY (VTech, Electronic Tini-Arcade) Simulator                    * }
{ * by Luca "MADrigal" Antignano, September 2011 (revision: September 2017)  * }
{ *                                                                          * }
{ * http://www.madrigaldesign.it/sim/                                        * }
{ * lucantignano@gmail.com                                                   * }
{ *                                                                          * }
{ * This source code (the "Software") is released as "open source" under the * }
{ * "Creative Common Attribution-NonCommercial-ShareAlike" license 4.0       * }
{ * available at:                                                            * }
{ * https://creativecommons.org/licenses/by-nc-sa/4.0/legalcode              * }
{ *                                                                          * }
{ * In addition to the constraints set by the CC license, you must respect   * }
{ * the following rules:                                                     * }
{ * a. do not offer the Software on a pay-per-play basis.                    * }
{ * b. do not distribute the Software through pre-paid access websites or    * }
{ *    BBS's.                                                                * }
{ * c. do not use the Software in publications of any form unless written    * }
{ *    consent is obtained by the author.                                    * }
{ * d. do not distribute the Software through mirror websites, unless        * }
{ *    written consent is obtained by the author.                            * }
{ * e. do not distribute older versions of the Software through authorized   * }
{ *    mirror websites after newer ones have been made available by the      * }
{ *    author.                                                               * }
{ *                                                                          * }
{ * Excerpt from the CC BY-NC-SA license 4.0                                 * }
{ * ========================================                                 * }
{ * BY: You must give appropriate credit, provide a link to the license, and * }
{ *     indicate if changes were made. You may do so in any reasonable       * }
{ *     manner, but not in any way that suggests the licensor endorses you   * }
{ *     or your use.                                                         * }
{ * NC: You may not use the material for commercial purposes.                * }
{ * SA: If you remix, transform, or build upon the material, you must        * }
{ *     distribute your contributions under the same license as the          * }
{ *     original.                                                            * }
{ *                                                                          * }
{ **************************************************************************** }

unit gfxinit;
{ this unit contains the graphics initialization (skin-based system)           }

interface

uses
  Forms, Controls, StdCtrls, SysUtils, Classes, Graphics, ExtCtrls, Dialogs,
  Jpeg, Pngimage, IniFiles;

{ * PROCEDURES: SKIN INITIALIZATION                                          * }
procedure Gfx_Game_Init;
procedure Gfx_Manual_Init;

const
  INIFILE = 'Config.ini';

{}IMAGES = 198;

{}DEFAULTHEIGHT    = 747;
{}DEFAULTWIDTH     = 692;
  DEFAULTSKINDIR   = 'Graphics\Skin\';
  DEFAULTWINMODE   = 'Shaped';

  DEFAULTTRCOLOR   = '$00ff00ff';

  DEFAULTBDDIR     = 'Graphics\Backdrop\';
  DEFAULTBDFILE    = 'nil';
  DEFAULTBDSTRETCH = 0;
{}DEFAULTBGCOLOR   = '$00000000';
  DEFAULTOFFSETX   = 'Center';
  DEFAULTOFFSETY   = 'Center';
  DEFAULTLOGOFILE  = 'nil';
  DEFAULTLOGOPOS   = 1;

  DEFAULTMANUALDIR = 'Graphics\Manual\';
{}DEFAULTMANHEIGHT = 700;
{}DEFAULTMANWIDTH  = 500;

var
  IF_File: TIniFile;
  aImages: array [1..IMAGES] of TImage;
{}//sVideoMode: string;

implementation

uses
  {manual,} splash, unit1;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: SKIN INITIALIZATION                                          * }
{ *                                                                          * }
{ **************************************************************************** }

procedure Gfx_Game_Init;
{ initializes the graphics on the main game form                               }
  var
    // service variables
    i,
    iOffsetX,
    iOffsetY: integer;

    // temporary variables (used to read/write from 'ini file')
    sSkinDir,
    sBackdropDir,
    sBackdropFile,
    sGameOffsetX,
    sGameOffsetY,
{}  sLogoFile: string;
{}//sWindowMode

    // image variables
    sFilename: string;
begin
  // initialises array of images
  with Form1 do
    begin
      aImages[1] := im_background; aImages[2] := im_background_screen_top;
      aImages[3] := im_background_screen;

      aImages[4] := btn_power_top; aImages[5] := btn_power_on;
      aImages[6] := btn_select_top; aImages[7] := btn_select_down;
      aImages[8] := btn_start_top; aImages[9] := btn_start_down;

      aImages[10] := btn_joystick_top;

      aImages[11] := btn_ctrlr_overlay_up;
      aImages[12] := btn_ctrlr_overlay_left;
      aImages[13] := btn_ctrlr_overlay_right;
      aImages[14] := btn_ctrlr_overlay_down;

      aImages[15] := im_panel_gameover;

      aImages[16] := im_panel_lives_1; aImages[17] := im_panel_lives_2;

      aImages[18] := im_panel_digit_pos_1; aImages[19] := im_panel_digit_pos_2; aImages[20] := im_panel_digit_pos_3; aImages[21] := im_panel_digit_pos_4; aImages[22] := im_panel_digit_pos_5;

      aImages[23] := im_panel_number_0; aImages[24] := im_panel_number_1; aImages[25] := im_panel_number_2; aImages[26] := im_panel_number_3; aImages[27] := im_panel_number_4;
      aImages[28] := im_panel_number_5; aImages[29] := im_panel_number_6; aImages[30] := im_panel_number_7; aImages[31] := im_panel_number_8; aImages[32] := im_panel_number_9;

      aImages[33] := im_chewy_02_07; aImages[34] := im_chewy_03_07; aImages[35] := im_chewy_04_07; aImages[36] := im_chewy_05_07; aImages[37] := im_chewy_06_07; aImages[38] := im_chewy_07_07; aImages[39] := im_chewy_08_07; aImages[40] := im_chewy_09_07;
      aImages[41] := im_chewy_02_06; aImages[42] := im_chewy_03_06; aImages[43] := im_chewy_04_06; aImages[44] := im_chewy_05_06; aImages[45] := im_chewy_06_06; aImages[46] := im_chewy_07_06; aImages[47] := im_chewy_08_06; aImages[48] := im_chewy_09_06;
      aImages[49] := im_chewy_02_05; aImages[50] := im_chewy_03_05; aImages[51] := im_chewy_04_05; aImages[52] := im_chewy_05_05; aImages[53] := im_chewy_06_05; aImages[54] := im_chewy_07_05; aImages[55] := im_chewy_08_05; aImages[56] := im_chewy_09_05;
      aImages[57] := im_chewy_02_04; aImages[58] := im_chewy_03_04; aImages[59] := im_chewy_04_04; aImages[60] := im_chewy_07_04; aImages[61] := im_chewy_08_04; aImages[62] := im_chewy_09_04;
      aImages[63] := im_chewy_02_03; aImages[64] := im_chewy_03_03; aImages[65] := im_chewy_04_03; aImages[66] := im_chewy_05_03; aImages[67] := im_chewy_06_03; aImages[68] := im_chewy_07_03; aImages[69] := im_chewy_08_03; aImages[70] := im_chewy_09_03;
      aImages[71] := im_chewy_02_02; aImages[72] := im_chewy_03_02; aImages[73] := im_chewy_04_02; aImages[74] := im_chewy_05_02; aImages[75] := im_chewy_06_02; aImages[76] := im_chewy_07_02; aImages[77] := im_chewy_08_02; aImages[78] := im_chewy_09_02;
      aImages[79] := im_chewy_02_01; aImages[80] := im_chewy_03_01; aImages[81] := im_chewy_04_01; aImages[82] := im_chewy_05_01; aImages[83] := im_chewy_06_01; aImages[84] := im_chewy_07_01; aImages[85] := im_chewy_08_01; aImages[86] := im_chewy_09_01;

      aImages[87] := im_pill_02_07; aImages[88] := im_pill_03_07; aImages[89] := im_pill_04_07; aImages[90] := im_pill_05_07; aImages[91] := im_pill_06_07; aImages[92] := im_pill_07_07; aImages[93] := im_pill_08_07; aImages[94] := im_pill_09_07;
      aImages[95] := im_pill_02_06; aImages[96] := im_pill_03_06; aImages[97] := im_pill_04_06; aImages[98] := im_pill_05_06; aImages[99] := im_pill_06_06; aImages[100] := im_pill_07_06; aImages[101] := im_pill_08_06; aImages[102] := im_pill_09_06;
      aImages[103] := im_pill_02_05; aImages[104] := im_pill_03_05; aImages[105] := im_pill_04_05; aImages[106] := im_pill_05_05; aImages[107] := im_pill_06_05; aImages[108] := im_pill_07_05; aImages[109] := im_pill_08_05; aImages[110] := im_pill_09_05;
      aImages[111] := im_pill_02_04; aImages[112] := im_pill_03_04; aImages[113] := im_pill_04_04; aImages[114] := im_pill_07_04; aImages[115] := im_pill_08_04; aImages[116] := im_pill_09_04;
      aImages[117] := im_pill_02_03; aImages[118] := im_pill_03_03; aImages[119] := im_pill_04_03; aImages[120] := im_pill_05_03; aImages[121] := im_pill_06_03; aImages[122] := im_pill_07_03; aImages[123] := im_pill_08_03; aImages[124] := im_pill_09_03;
      aImages[125] := im_pill_02_02; aImages[126] := im_pill_03_02; aImages[127] := im_pill_04_02; aImages[128] := im_pill_05_02; aImages[129] := im_pill_06_02; aImages[130] := im_pill_07_02; aImages[131] := im_pill_08_02; aImages[132] := im_pill_09_02;
      aImages[133] := im_pill_02_01; aImages[134] := im_pill_03_01; aImages[135] := im_pill_04_01; aImages[136] := im_pill_05_01; aImages[137] := im_pill_06_01; aImages[138] := im_pill_07_01; aImages[139] := im_pill_08_01; aImages[140] := im_pill_09_01;

      aImages[141] := im_ghost_02_07; aImages[142] := im_ghost_03_07; aImages[143] := im_ghost_04_07; aImages[144] := im_ghost_05_07; aImages[145] := im_ghost_06_07; aImages[146] := im_ghost_07_07; aImages[147] := im_ghost_08_07; aImages[148] := im_ghost_09_07;
      aImages[149] := im_ghost_02_06; aImages[150] := im_ghost_03_06; aImages[151] := im_ghost_04_06; aImages[152] := im_ghost_05_06; aImages[153] := im_ghost_06_06; aImages[154] := im_ghost_07_06; aImages[155] := im_ghost_08_06; aImages[156] := im_ghost_09_06;
      aImages[157] := im_ghost_02_05; aImages[158] := im_ghost_03_05; aImages[159] := im_ghost_04_05; aImages[160] := im_ghost_05_05; aImages[161] := im_ghost_06_05; aImages[162] := im_ghost_07_05; aImages[163] := im_ghost_08_05; aImages[164] := im_ghost_09_05;
      aImages[165] := im_ghost_02_04; aImages[166] := im_ghost_03_04; aImages[167] := im_ghost_04_04; aImages[168] := im_ghost_05_04; aImages[169] := im_ghost_06_04; aImages[170] := im_ghost_07_04; aImages[171] := im_ghost_08_04; aImages[172] := im_ghost_09_04;
      aImages[173] := im_ghost_05_04_b; aImages[174] := im_ghost_06_04_b;
      aImages[175] := im_ghost_02_03; aImages[176] := im_ghost_03_03; aImages[177] := im_ghost_04_03; aImages[178] := im_ghost_05_03; aImages[179] := im_ghost_06_03; aImages[180] := im_ghost_07_03; aImages[181] := im_ghost_08_03; aImages[182] := im_ghost_09_03;
      aImages[183] := im_ghost_02_02; aImages[184] := im_ghost_03_02; aImages[185] := im_ghost_04_02; aImages[186] := im_ghost_05_02; aImages[187] := im_ghost_06_02; aImages[188] := im_ghost_07_02; aImages[189] := im_ghost_08_02; aImages[190] := im_ghost_09_02;
      aImages[191] := im_ghost_02_01; aImages[192] := im_ghost_03_01; aImages[193] := im_ghost_04_01; aImages[194] := im_ghost_05_01; aImages[195] := im_ghost_06_01; aImages[196] := im_ghost_07_01; aImages[197] := im_ghost_08_01; aImages[198] := im_ghost_09_01;
    end;

  // TO BE USED TO GENERATE THE SKIN FILE ONLY (TO BE COMMENTED THEREAFTER)
{  IF_File := TIniFile.Create(ExtractFilePath(ParamStr(0)) + 'Export.ini');

  for i := 1 to IMAGES do
    begin
      if aImages[i].Picture.Graphic = nil then
        sFilename := 'nil'
      else
        if aImages[i].Picture.Graphic is TJPEGImage then
          sFilename := aImages[i].Name + '.jpg'
        else
          if aImages[i].Picture.Graphic is TBitmap then
            sFilename := aImages[i].Name + '.bmp'
          else
            if aImages[i].Picture.Graphic is TPNGObject then
              sFilename := aImages[i].Name + '.png';

      IF_file.WriteString('Image' + IntToStr(i),  'Filename', sFilename);
      IF_file.WriteInteger('Image' + IntToStr(i), 'Height',   aImages[i].Height);
      IF_file.WriteInteger('Image' + IntToStr(i), 'Left',     aImages[i].Left);
      IF_file.WriteInteger('Image' + IntToStr(i), 'Top',      aImages[i].Top);
      IF_file.WriteInteger('Image' + IntToStr(i), 'Width',    aImages[i].Width);
    end;

  IF_File.Destroy; }

  // loads configuration settings from the Config.ini file
  if not FileExists(ExtractFilePath(ParamStr(0)) + INIFILE) then
    begin
      MessageDlg('Configuration file (Config.ini) not found. Please reinstall the game.', mtError, [mbOK], 0);
      Application.Terminate;
    end
  else
    begin
      // reads init values from 'ini file' -- with defaults if no 'ini file' found
      IF_File := TIniFile.Create(ExtractFilePath(ParamStr(0)) + INIFILE);

      // game form initialization (game graphics and backdrop)
      with Form1 do
        begin
          sSkinDir     := IncludeTrailingPathDelimiter(IF_file.ReadString('Common', 'SkinDir', DEFAULTSKINDIR));
          ClientHeight := IF_file.ReadInteger('Common', 'GameHeight', DEFAULTHEIGHT);
          ClientWidth  := IF_file.ReadInteger('Common', 'GameWidth',  DEFAULTWIDTH);

          // use Fullscreen or Shaped mode
{}        if bFullscreenMode then
            begin                                                               // Fullscreen
              // sets backdrop image and background colour
              sBackdropDir  := IncludeTrailingPathDelimiter(IF_file.ReadString('Fullscreen', 'BackdropDir',  DEFAULTBDDIR));
              sBackdropFile := IF_file.ReadString('Fullscreen', 'BackdropFile', DEFAULTBDFILE);

              if (sBackdropFile <> '')
                and (sBackdropFile <> 'nil') then
                if FileExists(sBackdropDir + sBackdropFile) then
                  begin
                    im_backdrop.Picture.LoadFromFile(sBackdropDir + sBackdropFile);
                    im_backdrop.Stretch := Boolean(IF_file.ReadInteger('Fullscreen', 'BackdropStretch', DEFAULTBDSTRETCH));
{}                  im_backdrop.Visible := true;
                  end;

              Color := StrToInt(IF_file.ReadString('Fullscreen', 'BgColor', DEFAULTBGCOLOR));
              TransparentColor := false;

              // sets new coordinates for the handheld game graphics
              sGameOffsetX := IF_file.ReadString('Fullscreen', 'GameOffsetX', DEFAULTOFFSETX);
              sGameOffsetY := IF_file.ReadString('Fullscreen', 'GameOffsetY', DEFAULTOFFSETY);

              if StrToIntDef(sGameOffsetX, 0) <> 0 then iOffsetX := StrToInt(sGameOffsetX) else iOffsetX := Trunc((Screen.Width  - ClientWidth)  / 2);
              if StrToIntDef(sGameOffsetY, 0) <> 0 then iOffsetY := StrToInt(sGameOffsetY) else iOffsetY := Trunc((Screen.Height - ClientHeight) / 2);

              // sets the form as full screen
              ClientWidth  := Screen.Width;
              ClientHeight := Screen.Height;

              // sets logo (watermark) image and its position
              sLogoFile := IF_file.ReadString('Fullscreen', 'LogoFile', DEFAULTLOGOFILE);

              if (sLogoFile <> '')
                and (sLogoFile <> 'nil') then
                if FileExists(sBackdropDir + sLogoFile) then
                  with Form1 do
                    begin
                      im_backdrop_logo.Picture.LoadFromFile(sBackdropDir + sLogoFile);
                      im_backdrop_logo.AutoSize := true;
{}                    im_backdrop_logo.Visible := true;

                      case IF_file.ReadInteger('Fullscreen', 'LogoPosition', DEFAULTLOGOPOS) of
                        0: begin im_backdrop_logo.Left := 0;                                    im_backdrop_logo.Top := 0; end; // top-left
                        1: begin im_backdrop_logo.Left := ClientWidth - im_backdrop_logo.Width; im_backdrop_logo.Top := 0; end; // top-right
                        2: begin im_backdrop_logo.Left := 0;                                    im_backdrop_logo.Top := ClientHeight - im_backdrop_logo.Height; end; // bottom-left
                        3: begin im_backdrop_logo.Left := ClientWidth - im_backdrop_logo.Width; im_backdrop_logo.Top := ClientHeight - im_backdrop_logo.Height; end; // bottom-right
                      end; // case..of
                    end;
            end
          else                                                                  // Shaped
            begin
              // sets coordinates for the handheld game graphics
              iOffsetX := 0;
              iOffsetY := 0;

              // sets the form as 'shaped'
              Color                 := StrToInt(IF_file.ReadString('VideoMode', 'TranspColor', DEFAULTTRCOLOR));
              TransparentColorValue := StrToInt(IF_file.ReadString('VideoMode', 'TranspColor', DEFAULTTRCOLOR));
              TransparentColor      := true;

              // disables the backdrop
              im_backdrop.Visible := false;
              im_backdrop_logo.Visible := false;
            end;
        end;

      // game skin initialization
      for i := 1 to IMAGES do
        begin
          sFilename := IF_file.ReadString('Image' + IntToStr(i), 'Filename', '');

          if (sFilename <> '')
            and (sFilename <> 'nil') then
            if FileExists(sSkinDir + sFilename) then
              // loads picture into the image
              aImages[i].Picture.LoadFromFile(sSkinDir + sFilename)
            else
              // image expected but not found -> creates a coloured square as a placeholder
              begin
                aImages[i].Picture.Bitmap.Create;
                aImages[i].Picture.Bitmap.Width  := 10;
                aImages[i].Picture.Bitmap.Height := 10;
                aImages[i].Picture.Bitmap.Canvas.Create;
                aImages[i].Picture.Bitmap.Canvas.Pen.Color := 0;
                aImages[i].Picture.Bitmap.Canvas.Pen.Style := psSolid;
                aImages[i].Picture.Bitmap.Canvas.Brush.Color := $000000ff;
                aImages[i].Picture.Bitmap.Canvas.Rectangle(0, 0, 10, 10);
              end;

          aImages[i].Height := IF_file.ReadInteger('Image' + IntToStr(i), 'Height', 0);
          aImages[i].Left   := IF_file.ReadInteger('Image' + IntToStr(i), 'Left',   0) + iOffsetX;
          aImages[i].Top    := IF_file.ReadInteger('Image' + IntToStr(i), 'Top',    0) + iOffsetY;
          aImages[i].Width  := IF_file.ReadInteger('Image' + IntToStr(i), 'Width',  0);
        end;

      // close Inifile
      IF_File.Destroy;
    end;

  // initializes the on-screen game menu
  with Form1 do
    begin
{}    btn_game_menu_top.Visible := bFullscreenMode;
{}    btn_game_menu_background.Visible := bFullscreenMode;

      btn_game_menu_background.Height := 32;
      btn_game_menu_background.Width := 36;
    end;
end;





procedure Gfx_Manual_Init;
{ initializes the graphics of the instructions manual form                     }
  var
    // service variables
    i: integer;

    // temporary variables (used to read/write from 'ini file')
    sManualDir: string;

    // image variables
    sFilename: string;
begin
  // reads init values from 'ini file' -- with defaults if no 'ini file' found
{  IF_File := TIniFile.Create(ExtractFilePath(ParamStr(0)) + INIFILE);

  // manual form initialization (graphics and sizes)
  with ManualForm do
    begin
      sManualDir   := IncludeTrailingPathDelimiter(IF_file.ReadString('Manual', 'ManualDir', DEFAULTMANUALDIR));

      ClientHeight := IF_file.ReadInteger('Manual', 'ManualHeight', DEFAULTMANHEIGHT);
      ClientWidth  := IF_file.ReadInteger('Manual', 'ManualWidth',  DEFAULTMANWIDTH);

      im_page_top.Left   := 0;
      im_page_top.Top    := 0;
      im_page_top.Height := ClientHeight;
      im_page_top.Width  := ClientWidth;

      sh_page_top.Left   := 0;
      sh_page_top.Top    := 0;
      sh_page_top.Height := ClientHeight;
      sh_page_top.Width  := ClientWidth;
    end;

  // instructions manual skin initialization
  for i := 1 to MANUALPAGES do
    begin
      sFilename := IntToStr(i) + '.bmp';

      if FileExists(sManualDir + sFilename) then
          // loads picture into the image
          aIm_pages[i].Picture.LoadFromFile(sManualDir + sFilename)
        else
          // image expected but not found -> creates a coloured square as a placeholder
          begin
            aIm_pages[i].Picture.Bitmap.Create;
            aIm_pages[i].Picture.Bitmap.Width  := 10;
            aIm_pages[i].Picture.Bitmap.Height := 10;
            aIm_pages[i].Picture.Bitmap.Canvas.Create;
            aIm_pages[i].Picture.Bitmap.Canvas.Pen.Color := 0;
            aIm_pages[i].Picture.Bitmap.Canvas.Pen.Style := psSolid;
            aIm_pages[i].Picture.Bitmap.Canvas.Brush.Color := $000000ff;
            aIm_pages[i].Picture.Bitmap.Canvas.Rectangle(0, 0, 10, 10);
          end;

      with ManualForm do
        begin
          aIm_pages[i].Height := ClientHeight;
          aIm_pages[i].Width  := ClientWidth;
        end;
    end;

  // close Inifile
  IF_File.Destroy; }
end;





end.
