{ **************************************************************************** }
{ *                                                                          * }
{ * CRAZY CHEWY (VTech, Electronic Tini-Arcade) Simulator                    * }
{ * by Luca "MADrigal" Antignano, September 2011 (revision: September 2017)  * }
{ *                                                                          * }
{ * http://www.madrigaldesign.it/sim/                                        * }
{ * lucantignano@gmail.com                                                   * }
{ *                                                                          * }
{ * This source code (the "Software") is released as "open source" under the * }
{ * "Creative Common Attribution-NonCommercial-ShareAlike" license 4.0       * }
{ * available at:                                                            * }
{ * https://creativecommons.org/licenses/by-nc-sa/4.0/legalcode              * }
{ *                                                                          * }
{ * In addition to the constraints set by the CC license, you must respect   * }
{ * the following rules:                                                     * }
{ * a. do not offer the Software on a pay-per-play basis.                    * }
{ * b. do not distribute the Software through pre-paid access websites or    * }
{ *    BBS's.                                                                * }
{ * c. do not use the Software in publications of any form unless written    * }
{ *    consent is obtained by the author.                                    * }
{ * d. do not distribute the Software through mirror websites, unless        * }
{ *    written consent is obtained by the author.                            * }
{ * e. do not distribute older versions of the Software through authorized   * }
{ *    mirror websites after newer ones have been made available by the      * }
{ *    author.                                                               * }
{ *                                                                          * }
{ * Excerpt from the CC BY-NC-SA license 4.0                                 * }
{ * ========================================                                 * }
{ * BY: You must give appropriate credit, provide a link to the license, and * }
{ *     indicate if changes were made. You may do so in any reasonable       * }
{ *     manner, but not in any way that suggests the licensor endorses you   * }
{ *     or your use.                                                         * }
{ * NC: You may not use the material for commercial purposes.                * }
{ * SA: If you remix, transform, or build upon the material, you must        * }
{ *     distribute your contributions under the same license as the          * }
{ *     original.                                                            * }
{ *                                                                          * }
{ **************************************************************************** }

unit unit1;
{ this unit contains the main form implementation                              }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Math, Registry, Jpeg, Pngimage, Fmod, Fmodtypes, StdCtrls, Menus,
  ShellAPI;

type
  TForm1 = class(TForm)
{ * HANDHELD GRAPHICS, INCLUDING BUTTONS                                     * }

    // fullscreen mode items
    btn_game_menu_top:        TImage;
    btn_game_menu_background: TImage;

    im_backdrop:              TImage;
    im_backdrop_logo:         TImage;

    // electronic game
    im_background:            TImage;    im_background_screen_top: TImage;
    im_background_screen:     TImage;

    btn_power_top:            TImage;    btn_power_on:             TImage;
    btn_select_top:           TImage;    btn_select_down:          TImage;
    btn_start_top:            TImage;    btn_start_down:           TImage;

    btn_joystick_top:         TImage;

    btn_ctrlr_overlay_up:     TImage;
    btn_ctrlr_overlay_left:   TImage;
    btn_ctrlr_overlay_right:  TImage;
    btn_ctrlr_overlay_down:   TImage;

{ * LCD SCREEN GRAPHICS (SPRITES)                                            * }

    // on-screen control panel
    im_panel_gameover: TImage;

    im_panel_lives_1: TImage; im_panel_lives_2: TImage;

    im_panel_digit_pos_1: TImage; im_panel_digit_pos_2: TImage; im_panel_digit_pos_3: TImage; im_panel_digit_pos_4: TImage; im_panel_digit_pos_5: TImage;

    im_panel_number_0: TImage; im_panel_number_1: TImage; im_panel_number_2: TImage; im_panel_number_3: TImage; im_panel_number_4: TImage;
    im_panel_number_5: TImage; im_panel_number_6: TImage; im_panel_number_7: TImage; im_panel_number_8: TImage; im_panel_number_9: TImage;

    // on-screen items
    im_chewy_02_07: TImage; im_chewy_03_07: TImage; im_chewy_04_07: TImage; im_chewy_05_07: TImage; im_chewy_06_07: TImage; im_chewy_07_07: TImage; im_chewy_08_07: TImage; im_chewy_09_07: TImage;
    im_chewy_02_06: TImage; im_chewy_03_06: TImage; im_chewy_04_06: TImage; im_chewy_05_06: TImage; im_chewy_06_06: TImage; im_chewy_07_06: TImage; im_chewy_08_06: TImage; im_chewy_09_06: TImage;
    im_chewy_02_05: TImage; im_chewy_03_05: TImage; im_chewy_04_05: TImage; im_chewy_05_05: TImage; im_chewy_06_05: TImage; im_chewy_07_05: TImage; im_chewy_08_05: TImage; im_chewy_09_05: TImage;
    im_chewy_02_04: TImage; im_chewy_03_04: TImage; im_chewy_04_04: TImage;                                                 im_chewy_07_04: TImage; im_chewy_08_04: TImage; im_chewy_09_04: TImage;
    im_chewy_02_03: TImage; im_chewy_03_03: TImage; im_chewy_04_03: TImage; im_chewy_05_03: TImage; im_chewy_06_03: TImage; im_chewy_07_03: TImage; im_chewy_08_03: TImage; im_chewy_09_03: TImage;
    im_chewy_02_02: TImage; im_chewy_03_02: TImage; im_chewy_04_02: TImage; im_chewy_05_02: TImage; im_chewy_06_02: TImage; im_chewy_07_02: TImage; im_chewy_08_02: TImage; im_chewy_09_02: TImage;
    im_chewy_02_01: TImage; im_chewy_03_01: TImage; im_chewy_04_01: TImage; im_chewy_05_01: TImage; im_chewy_06_01: TImage; im_chewy_07_01: TImage; im_chewy_08_01: TImage; im_chewy_09_01: TImage;

    im_pill_02_07: TImage;  im_pill_03_07: TImage;  im_pill_04_07: TImage;  im_pill_05_07: TImage;  im_pill_06_07: TImage;  im_pill_07_07: TImage;  im_pill_08_07: TImage;  im_pill_09_07: TImage;
    im_pill_02_06: TImage;  im_pill_03_06: TImage;  im_pill_04_06: TImage;  im_pill_05_06: TImage;  im_pill_06_06: TImage;  im_pill_07_06: TImage;  im_pill_08_06: TImage;  im_pill_09_06: TImage;
    im_pill_02_05: TImage;  im_pill_03_05: TImage;  im_pill_04_05: TImage;  im_pill_05_05: TImage;  im_pill_06_05: TImage;  im_pill_07_05: TImage;  im_pill_08_05: TImage;  im_pill_09_05: TImage;
    im_pill_02_04: TImage;  im_pill_03_04: TImage;  im_pill_04_04: TImage;                                                  im_pill_07_04: TImage;  im_pill_08_04: TImage;  im_pill_09_04: TImage;
    im_pill_02_03: TImage;  im_pill_03_03: TImage;  im_pill_04_03: TImage;  im_pill_05_03: TImage;  im_pill_06_03: TImage;  im_pill_07_03: TImage;  im_pill_08_03: TImage;  im_pill_09_03: TImage;
    im_pill_02_02: TImage;  im_pill_03_02: TImage;  im_pill_04_02: TImage;  im_pill_05_02: TImage;  im_pill_06_02: TImage;  im_pill_07_02: TImage;  im_pill_08_02: TImage;  im_pill_09_02: TImage;
    im_pill_02_01: TImage;  im_pill_03_01: TImage;  im_pill_04_01: TImage;  im_pill_05_01: TImage;  im_pill_06_01: TImage;  im_pill_07_01: TImage;  im_pill_08_01: TImage;  im_pill_09_01: TImage;

    im_ghost_02_07: TImage; im_ghost_03_07: TImage; im_ghost_04_07: TImage; im_ghost_05_07: TImage; im_ghost_06_07: TImage; im_ghost_07_07: TImage; im_ghost_08_07: TImage; im_ghost_09_07: TImage;
    im_ghost_02_06: TImage; im_ghost_03_06: TImage; im_ghost_04_06: TImage; im_ghost_05_06: TImage; im_ghost_06_06: TImage; im_ghost_07_06: TImage; im_ghost_08_06: TImage; im_ghost_09_06: TImage;
    im_ghost_02_05: TImage; im_ghost_03_05: TImage; im_ghost_04_05: TImage; im_ghost_05_05: TImage; im_ghost_06_05: TImage; im_ghost_07_05: TImage; im_ghost_08_05: TImage; im_ghost_09_05: TImage;
    im_ghost_02_04: TImage; im_ghost_03_04: TImage; im_ghost_04_04: TImage; im_ghost_05_04: TImage; im_ghost_06_04: TImage; im_ghost_07_04: TImage; im_ghost_08_04: TImage; im_ghost_09_04: TImage;
                                                                          im_ghost_05_04_b: TImage; im_ghost_06_04_b: TImage;
    im_ghost_02_03: TImage; im_ghost_03_03: TImage; im_ghost_04_03: TImage; im_ghost_05_03: TImage; im_ghost_06_03: TImage; im_ghost_07_03: TImage; im_ghost_08_03: TImage; im_ghost_09_03: TImage;
    im_ghost_02_02: TImage; im_ghost_03_02: TImage; im_ghost_04_02: TImage; im_ghost_05_02: TImage; im_ghost_06_02: TImage; im_ghost_07_02: TImage; im_ghost_08_02: TImage; im_ghost_09_02: TImage;
    im_ghost_02_01: TImage; im_ghost_03_01: TImage; im_ghost_04_01: TImage; im_ghost_05_01: TImage; im_ghost_06_01: TImage; im_ghost_07_01: TImage; im_ghost_08_01: TImage; im_ghost_09_01: TImage;

{ * TIMERS                                                                   * }
    Timer_Bonus_Star:     TTimer;
    Timer_Demo_Start:     TTimer;
    Timer_Game:           TTimer;
    Timer_Ghost:          TTimer;
    Timer_Miss:           TTimer;
    Timer_Stage_Complete: TTimer;

{ * POPUP MENU                                                               * }
    pm_0_menu:          TPopupMenu;
    pm_1_about:         TMenuItem;
    pm_2_readme:        TMenuItem;
    pm_3_whatsnew:      TMenuItem;
    pm_4_manual:        TMenuItem;
    pm_5_n1:            TMenuItem;
    pm_6_config:        TMenuItem;
    pm_7_keys:          TMenuItem;
    pm_9_n2:            TMenuItem;
  {}pm_10_fullscreen:   TMenuItem;
  {}pm_11_splashscreen: TMenuItem;
  {}pm_12_controller:   TMenuItem;
  {}pm_13_n3:           TMenuItem;
  {}pm_14_exit:         TMenuItem;

{ * PROCEDURES: INITIALIZE & SHUT DOWN                                       * }
    procedure FormCreate                 (Sender: TObject);
    procedure FormActivate               (Sender: TObject);
    procedure FormClose                  (Sender: TObject; var Action: TCloseAction);

{ * PROCEDURES: DISPLAY MANAGEMENT                                           * }
    procedure Vid_Display_Ctrl_Overlay;

    procedure Vid_Display_All_Sprites    (b: boolean);

    procedure Vid_Display_All_Chewy      (b: boolean);
    procedure Vid_Display_All_Pill       (b: boolean);
    procedure Vid_Display_All_Ghost      (b: boolean);

    procedure Vid_Display_Chewy          (var p, q: integer; b: boolean);
    procedure Vid_Display_Ghost          (var p: integer;    b: boolean);

    procedure Vid_Display_Panel_Score    (var p: integer;    b: boolean);
    procedure Vid_Display_Panel_Life     (var p: integer);

{ * PROCEDURES: AUDIO MANAGEMENT                                             * }
    procedure Snd_Play                   (pfs: PFSoundSample);
    procedure Snd_Silence;

{ * PROCEDURES: INPUT MANAGEMENT - EVENTS                                    * }
    procedure im_backgroundMouseDown     (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure im_backgroundMouseMove     (Sender: TObject;                       Shift: TShiftState; X, Y: Integer);

    procedure btn_power_topMouseDown     (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_select_topMouseDown    (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_select_topMouseUp      (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_start_topMouseDown     (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_start_topMouseUp       (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

    procedure btn_ctrlr_overlay_upMouseDown(Sender:TObject;Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_ctrlr_overlay_upMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_ctrlr_overlay_leftMouseDown(Sender:TObject;Button:TMouseButton;Shift: TShiftState; X, Y: Integer);
    procedure btn_ctrlr_overlay_rightMouseDown(Sender:TObject;Button:TMouseButton;Shift:TShiftState; X, Y: Integer);
    procedure btn_ctrlr_overlay_leftMouseUp(Sender:TObject;Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_ctrlr_overlay_rightMouseUp(Sender:TObject;Button:TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_ctrlr_overlay_downMouseDown(Sender:TObject;Button:TMouseButton;Shift: TShiftState; X, Y: Integer);
    procedure btn_ctrlr_overlay_downMouseUp(Sender:TObject;Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

    procedure FormKeyDown                (Sender: TObject; var Key: Word;        Shift: TShiftState);
    procedure FormKeyUp                  (Sender: TObject; var Key: Word;        Shift: TShiftState);

{ * PROCEDURES: INPUT MANAGEMENT - ACTIONS                                   * }
    procedure Inp_power_down;
    procedure Inp_select_down;           procedure Inp_select_up;
    procedure Inp_start_down;            procedure Inp_start_up;

    procedure Inp_arrow_right_down;      procedure Inp_arrow_right_up;
    procedure Inp_arrow_up_down;         procedure Inp_arrow_up_up;
    procedure Inp_arrow_left_down;       procedure Inp_arrow_left_up;
    procedure Inp_arrow_down_down;       procedure Inp_arrow_down_up;

{ * PROCEDURES: GAME ROUTINES                                                * }
    procedure Gam_Stop_All_Timers;

    procedure Gam_Set_Mode;
    procedure Gam_Init_Stage_Chewy;
    procedure Gam_Init_Stage_Ghosts;
    procedure Gam_Init_Stage_Labyrinth;
    procedure Gam_Init_Game;
    procedure Gam_Set_Bonus_Stars;
    procedure Gam_Start_Stage;
    procedure Gam_Move_Ghosts;
    function  Gam_Check_Chasing_Ghost:   boolean;
    function  Gam_Check_Escaping_Ghost:  boolean;
    procedure Gam_Check_New_Life;

{ * PROCEDURES: TIMERS                                                       * }
    procedure Timer_Bonus_StarTimer      (Sender: TObject);
    procedure Timer_Demo_StartTimer      (Sender: TObject);
    procedure Timer_GameTimer            (Sender: TObject);
    procedure Timer_GhostTimer           (Sender: TObject);
    procedure Timer_MissTimer            (Sender: TObject);
    procedure Timer_Stage_CompleteTimer  (Sender: TObject);

{ * PROCEDURES: POPUP MENU MANAGEMENT                                        * }
    procedure pm_0_menuPopup             (Sender: TObject);
    procedure pm_1_aboutClick            (Sender: TObject);
    procedure pm_2_readmeClick           (Sender: TObject);
    procedure pm_3_whatsnewClick         (Sender: TObject);
    procedure pm_4_manualClick           (Sender: TObject);
    procedure pm_6_configClick           (Sender: TObject);
    procedure pm_7_keysClick             (Sender: TObject);
  {}procedure pm_10_fullscreenClick      (Sender: TObject);
  {}procedure pm_11_splashscreenClick    (Sender: TObject);
  {}procedure pm_12_controllerClick      (Sender: TObject);
  {}procedure pm_14_exitClick            (Sender: TObject);

{ * PROCEDURES: GAME MENU MANAGEMENT                                         * }
    procedure btn_game_menu_topClick     (Sender: TObject);

    procedure la_menu_itemMouseEnter     (Sender: TObject);
    procedure la_menu_itemMouseLeave     (Sender: TObject);
    procedure la_menu_itemMouseUp        (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

    procedure Vid_Display_Game_Menu      (b: boolean);
  end;

const
  APP_NAME       = 'Crazy Chewy (VTech, Electronic Tini-Arcade) Simulator';     // application's name (appears on taskbar and Splash screen)
{}APP_VERSION    = 'Version 5.00 * Final *';                                    // current version (appears on Splash screen)
{}APP_DATE       = 'Released by Luca "MADrigal" Antignano on 4th December, 2017'; // release date (appears on Splash screen)
  URL_EMAIL      = 'mailto:lucantignano@gmail.com';                             // link to the email address
  URL_PAYPAL     = 'https://www.paypal.me/LucaAntignano';                       // link to the Paypal donation page
  URL_WEBSITE    = 'http://www.madrigaldesign.it/sim/';                         // link to the website
  REG_KEY        = 'Software\MADrigal\CrazyCwT50';                              // registry key

  HINT_CLICK     = 'click or press';
  HINT_POWER_OFF = 'to turn on the game';
  HINT_POWER_ON  = 'to turn off the game';
  HINT_SELECT    = 'to select game';
  HINT_START     = 'to start game';
  HINT_JOYSTICK  = 'activate the controller overlays or use';

{}MENU_ITEMS = 13;
  NUM_KEYS = 7;

  BONUS_STAR_ON      = 6;
  BONUS_STAR_OFF     = 24;
  CHEWY_SPEED        = 4;
  ENERGIZER_DURATION = 23;

var
{ * main objects * }
  Form1:                   TForm1;                                              // main form
  bStartup:                boolean;                                             // manages splash screen at startup
  iMouseX, iMouseY:        integer;                                             // cursor coordinates (to drag main form)
  iReg:                    TRegIniFile;                                         // system registry (to save settings)

{ * sound management * }
  pfs_bonus,
  pfs_energiz,
  pfs_ghost,
  pfs_miss,
  pfs_pill,
  pfs_pill_alt,
  pfs_stage,
  pfs_start:               PFSoundSample;                                       // sound samples

  bSound:                  boolean;                                             // sound enabled? (depending on selected driver on splash screen)

{ * arrays of images * }
  aIm_panel_score:         array[1..5]       of TImage;                         // panel: empty sprites to host score/time digits
  aIm_panel_numbers:       array[0..9]       of TImage;
  aIm_panel_lives:         array[1..2]       of TImage;                         // panel: lives (1-3)

  aIm_chewy,
  aIm_pill,
  aIm_ghost:               array [2..9, 1..7]  of TImage;

{ * arrays of numbers * }
  aLabyrinth:              array [1..10, 1..7] of integer;                      // allowed directions (0=none; 1=left; 2=up; 4=right; 8=down; ... various combinations 9 to 15)
                                                                                  // 0,  9, 13, 13, 12,  9, 13, 13, 12,  0
                                                                                  // 0, 10, 10,  3, 14, 11,  6, 10, 10,  0
                                                                                  // 5,  7, 15,  5,  7,  7,  5, 15,  7,  5
                                                                                  // 0,  9,  7, 12,  3,  6,  9,  7, 12,  0
                                                                                  // 5, 15,  5, 15, 12,  9, 15,  5, 15,  5
                                                                                  // 0, 11,  5,  6, 11, 14,  3,  5, 14,  0
                                                                                  // 0,  3,  5,  5,  6,  3,  5,  5,  6,  0
  aPill:                   array [1..10, 1..7] of integer;                      // pills in labyrinth (0=empty; 1=pill; 2=energizer; 3=bonus star)
  aGhost:                  array [1..3]        of record
                                                    iStatus,                    // 0=off, 1=chasing, 2=escaping
                                                    iPosX,                      // 1-10 (2-9 on lcd screen, 1 and 10 not visible)
                                                    iPosY:   integer;           // 1-7
                                                  end;

{ * arrays of mixed types *}
  aKeys:                   array[1..NUM_KEYS] of record                         // keys management (values)
                                                   int:  integer;
                                                   word: word;
                                                end;

  aKeyHints:               array[1..44] of string;                              // keys management (hint on buttons)

  aMenuItem:               array[1..MENU_ITEMS] of TMenuItem;                   // popup menu items
  aMenuLabels:             array[1..MENU_ITEMS] of TLabel;                      // on-screen game menu labels

{ * integers and booleans* }
  iMode,                                                                        // 0=off, 1=demo 1/2, 2=demo 2/2, 3-6=select 1-4, 7-10=game 1-4, 11-14=game over 1-4
  iScore,                                                                       // 00000-99999
  iScoreLastBonusStar,                                                          // 00000-99999 (score when Chewy eats a Bonus Star)
  iLivesLeft,                                                                   // 0-2 (no bonus life is awarded if iLivesLeft=2)
  iPillsToGo,                                                                   // 0-52 (48 pills + 4 energizers, bonus stars not included)
  iScoreNextBonusLife,                                                          // 20.000, 40.000, etc.

  iChewyPosX,                                                                   // 1-10 (2-9 on lcd screen, 1 and 10 not visible)
  iChewyPosY,                                                                   // 1-7

  iChewyDirection,                                                              // 1, 2, 4 or 8

  iStage,                                                                       // 1-no limit
  iGhostSpeed,                                                                  // 3 or 5    (depending on game mode and stage)
  iGhostsOnStage,                                                               // 1, 2 or 3 (depending on game mode and stage)

  iLoopGame,                                                                    // used in Timer_Game, loops between 1-(iGhostSpeed * CHEWY_SPEED)
  iLoopGameEnergizer,                                                           // used in Timer_Game, loops between 1-(iEnergizerDuration * CHEWY_SPEED)
  iLoopGameBonusStar,                                                           // used in Timer_Game, loops between 1-(iBonusStarDuration * CHEWY_SPEED)

  iLoopBonusStar,                                                               // used in Timer_Bonus_Star
  iLoopStageComplete,                                                           // used in Timer_Stage_Complete
  iLoopGhost,                                                                   // used in Timer_Ghost
  iLoopMiss                                                                     // used in Timer_Miss
                         : integer;

{}bFullscreenMode,                                                              // true if video mode is fullscreen (false if "shaped game")
  bGameMenuOpen,                                                                // true if the on-screen menu is visible
  bDisplayCtrlOverlays,                                                         // true if the controller overlay should be displayed

  bRightArrowKeyPressed,                                                        // true while right arrow key is being kept pressed
  bUpArrowKeyPressed,                                                           // true while up arrow key    is being kept pressed
  bLeftArrowKeyPressed,                                                         // true while left arrow key  is being kept pressed
  bDownArrowKeyPressed                                                          // true while down arrow key  is being kept pressed
                         : boolean;

implementation

uses
  about, gfxinit, keys, {manual,} splash;

{$r *.dfm}










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: INITIALIZE & SHUT DOWN                                       * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.FormCreate(Sender: TObject);
{ sprites on form are associated to arrays of images, needed to "index" them   }
{ variables are initialized: system registry, randomize, game mode, etc.       }
  var
    i: integer;
begin
  // initializes application name (for Windows taskbar)
  Application.Title := APP_NAME;

{}// sets game off the screen while graphics initialise
{}Top  := - Screen.Height;
{}Left := - Screen.Width;

  // on-screen panel
  aIm_panel_score[1] := im_panel_digit_pos_1; aIm_panel_score[2] := im_panel_digit_pos_2; aIm_panel_score[3] := im_panel_digit_pos_3; aIm_panel_score[4] := im_panel_digit_pos_4; aIm_panel_score[5] := im_panel_digit_pos_5;

  aIm_panel_numbers[0] := im_panel_number_0; aIm_panel_numbers[1] := im_panel_number_1; aIm_panel_numbers[2] := im_panel_number_2; aIm_panel_numbers[3] := im_panel_number_3; aIm_panel_numbers[4] := im_panel_number_4;
  aIm_panel_numbers[5] := im_panel_number_5; aIm_panel_numbers[6] := im_panel_number_6; aIm_panel_numbers[7] := im_panel_number_7; aIm_panel_numbers[8] := im_panel_number_8; aIm_panel_numbers[9] := im_panel_number_9;

  aIm_panel_lives[1] := im_panel_lives_1; aIm_panel_lives[2] := im_panel_lives_2;

  // on-screen items
  aIm_chewy[2, 7] := im_chewy_02_07; aIm_chewy[3, 7] := im_chewy_03_07; aIm_chewy[4, 7] := im_chewy_04_07; aIm_chewy[5, 7] := im_chewy_05_07; aIm_chewy[6, 7] := im_chewy_06_07; aIm_chewy[7, 7] := im_chewy_07_07; aIm_chewy[8, 7] := im_chewy_08_07; aIm_chewy[9, 7] := im_chewy_09_07;
  aIm_chewy[2, 6] := im_chewy_02_06; aIm_chewy[3, 6] := im_chewy_03_06; aIm_chewy[4, 6] := im_chewy_04_06; aIm_chewy[5, 6] := im_chewy_05_06; aIm_chewy[6, 6] := im_chewy_06_06; aIm_chewy[7, 6] := im_chewy_07_06; aIm_chewy[8, 6] := im_chewy_08_06; aIm_chewy[9, 6] := im_chewy_09_06;
  aIm_chewy[2, 5] := im_chewy_02_05; aIm_chewy[3, 5] := im_chewy_03_05; aIm_chewy[4, 5] := im_chewy_04_05; aIm_chewy[5, 5] := im_chewy_05_05; aIm_chewy[6, 5] := im_chewy_06_05; aIm_chewy[7, 5] := im_chewy_07_05; aIm_chewy[8, 5] := im_chewy_08_05; aIm_chewy[9, 5] := im_chewy_09_05;
  aIm_chewy[2, 4] := im_chewy_02_04; aIm_chewy[3, 4] := im_chewy_03_04; aIm_chewy[4, 4] := im_chewy_04_04;                                                                       aIm_chewy[7, 4] := im_chewy_07_04; aIm_chewy[8, 4] := im_chewy_08_04; aIm_chewy[9, 4] := im_chewy_09_04;
  aIm_chewy[2, 3] := im_chewy_02_03; aIm_chewy[3, 3] := im_chewy_03_03; aIm_chewy[4, 3] := im_chewy_04_03; aIm_chewy[5, 3] := im_chewy_05_03; aIm_chewy[6, 3] := im_chewy_06_03; aIm_chewy[7, 3] := im_chewy_07_03; aIm_chewy[8, 3] := im_chewy_08_03; aIm_chewy[9, 3] := im_chewy_09_03;
  aIm_chewy[2, 2] := im_chewy_02_02; aIm_chewy[3, 2] := im_chewy_03_02; aIm_chewy[4, 2] := im_chewy_04_02; aIm_chewy[5, 2] := im_chewy_05_02; aIm_chewy[6, 2] := im_chewy_06_02; aIm_chewy[7, 2] := im_chewy_07_02; aIm_chewy[8, 2] := im_chewy_08_02; aIm_chewy[9, 2] := im_chewy_09_02;
  aIm_chewy[2, 1] := im_chewy_02_01; aIm_chewy[3, 1] := im_chewy_03_01; aIm_chewy[4, 1] := im_chewy_04_01; aIm_chewy[5, 1] := im_chewy_05_01; aIm_chewy[6, 1] := im_chewy_06_01; aIm_chewy[7, 1] := im_chewy_07_01; aIm_chewy[8, 1] := im_chewy_08_01; aIm_chewy[9, 1] := im_chewy_09_01;

  aIm_pill[2, 7] := im_pill_02_07;   aIm_pill[3, 7] := im_pill_03_07;   aIm_pill[4, 7] := im_pill_04_07;   aIm_pill[5, 7] := im_pill_05_07;   aIm_pill[6, 7] := im_pill_06_07;   aIm_pill[7, 7] := im_pill_07_07;   aIm_pill[8, 7] := im_pill_08_07;   aIm_pill[9, 7] := im_pill_09_07;
  aIm_pill[2, 6] := im_pill_02_06;   aIm_pill[3, 6] := im_pill_03_06;   aIm_pill[4, 6] := im_pill_04_06;   aIm_pill[5, 6] := im_pill_05_06;   aIm_pill[6, 6] := im_pill_06_06;   aIm_pill[7, 6] := im_pill_07_06;   aIm_pill[8, 6] := im_pill_08_06;   aIm_pill[9, 6] := im_pill_09_06;
  aIm_pill[2, 5] := im_pill_02_05;   aIm_pill[3, 5] := im_pill_03_05;   aIm_pill[4, 5] := im_pill_04_05;   aIm_pill[5, 5] := im_pill_05_05;   aIm_pill[6, 5] := im_pill_06_05;   aIm_pill[7, 5] := im_pill_07_05;   aIm_pill[8, 5] := im_pill_08_05;   aIm_pill[9, 5] := im_pill_09_05;
  aIm_pill[2, 4] := im_pill_02_04;   aIm_pill[3, 4] := im_pill_03_04;   aIm_pill[4, 4] := im_pill_04_04;                                                                         aIm_pill[7, 4] := im_pill_07_04;   aIm_pill[8, 4] := im_pill_08_04;   aIm_pill[9, 4] := im_pill_09_04;
  aIm_pill[2, 3] := im_pill_02_03;   aIm_pill[3, 3] := im_pill_03_03;   aIm_pill[4, 3] := im_pill_04_03;   aIm_pill[5, 3] := im_pill_05_03;   aIm_pill[6, 3] := im_pill_06_03;   aIm_pill[7, 3] := im_pill_07_03;   aIm_pill[8, 3] := im_pill_08_03;   aIm_pill[9, 3] := im_pill_09_03;
  aIm_pill[2, 2] := im_pill_02_02;   aIm_pill[3, 2] := im_pill_03_02;   aIm_pill[4, 2] := im_pill_04_02;   aIm_pill[5, 2] := im_pill_05_02;   aIm_pill[6, 2] := im_pill_06_02;   aIm_pill[7, 2] := im_pill_07_02;   aIm_pill[8, 2] := im_pill_08_02;   aIm_pill[9, 2] := im_pill_09_02;
  aIm_pill[2, 1] := im_pill_02_01;   aIm_pill[3, 1] := im_pill_03_01;   aIm_pill[4, 1] := im_pill_04_01;   aIm_pill[5, 1] := im_pill_05_01;   aIm_pill[6, 1] := im_pill_06_01;   aIm_pill[7, 1] := im_pill_07_01;   aIm_pill[8, 1] := im_pill_08_01;   aIm_pill[9, 1] := im_pill_09_01;

  aIm_ghost[2, 7] := im_ghost_02_07; aIm_ghost[3, 7] := im_ghost_03_07; aIm_ghost[4, 7] := im_ghost_04_07; aIm_ghost[5, 7] := im_ghost_05_07; aIm_ghost[6, 7] := im_ghost_06_07; aIm_ghost[7, 7] := im_ghost_07_07; aIm_ghost[8, 7] := im_ghost_08_07; aIm_ghost[9, 7] := im_ghost_09_07;
  aIm_ghost[2, 6] := im_ghost_02_06; aIm_ghost[3, 6] := im_ghost_03_06; aIm_ghost[4, 6] := im_ghost_04_06; aIm_ghost[5, 6] := im_ghost_05_06; aIm_ghost[6, 6] := im_ghost_06_06; aIm_ghost[7, 6] := im_ghost_07_06; aIm_ghost[8, 6] := im_ghost_08_06; aIm_ghost[9, 6] := im_ghost_09_06;
  aIm_ghost[2, 5] := im_ghost_02_05; aIm_ghost[3, 5] := im_ghost_03_05; aIm_ghost[4, 5] := im_ghost_04_05; aIm_ghost[5, 5] := im_ghost_05_05; aIm_ghost[6, 5] := im_ghost_06_05; aIm_ghost[7, 5] := im_ghost_07_05; aIm_ghost[8, 5] := im_ghost_08_05; aIm_ghost[9, 5] := im_ghost_09_05;
  aIm_ghost[2, 4] := im_ghost_02_04; aIm_ghost[3, 4] := im_ghost_03_04; aIm_ghost[4, 4] := im_ghost_04_04; aIm_ghost[5, 4] := im_ghost_05_04; aIm_ghost[6, 4] := im_ghost_06_04; aIm_ghost[7, 4] := im_ghost_07_04; aIm_ghost[8, 4] := im_ghost_08_04; aIm_ghost[9, 4] := im_ghost_09_04;
  aIm_ghost[2, 3] := im_ghost_02_03; aIm_ghost[3, 3] := im_ghost_03_03; aIm_ghost[4, 3] := im_ghost_04_03; aIm_ghost[5, 3] := im_ghost_05_03; aIm_ghost[6, 3] := im_ghost_06_03; aIm_ghost[7, 3] := im_ghost_07_03; aIm_ghost[8, 3] := im_ghost_08_03; aIm_ghost[9, 3] := im_ghost_09_03;
  aIm_ghost[2, 2] := im_ghost_02_02; aIm_ghost[3, 2] := im_ghost_03_02; aIm_ghost[4, 2] := im_ghost_04_02; aIm_ghost[5, 2] := im_ghost_05_02; aIm_ghost[6, 2] := im_ghost_06_02; aIm_ghost[7, 2] := im_ghost_07_02; aIm_ghost[8, 2] := im_ghost_08_02; aIm_ghost[9, 2] := im_ghost_09_02;
  aIm_ghost[2, 1] := im_ghost_02_01; aIm_ghost[3, 1] := im_ghost_03_01; aIm_ghost[4, 1] := im_ghost_04_01; aIm_ghost[5, 1] := im_ghost_05_01; aIm_ghost[6, 1] := im_ghost_06_01; aIm_ghost[7, 1] := im_ghost_07_01; aIm_ghost[8, 1] := im_ghost_08_01; aIm_ghost[9, 1] := im_ghost_09_01;

  // set up labyrinth
  aLabyrinth[1, 7] :=  0; aLabyrinth[2, 7] :=  9; aLabyrinth[3, 7] := 13; aLabyrinth[4, 7] := 13; aLabyrinth[5, 7] := 12; aLabyrinth[6, 7] :=  9; aLabyrinth[7, 7] := 13; aLabyrinth[8, 7] := 13; aLabyrinth[9, 7] := 12; aLabyrinth[10, 7] :=  0;
  aLabyrinth[1, 6] :=  0; aLabyrinth[2, 6] := 10; aLabyrinth[3, 6] := 10; aLabyrinth[4, 6] :=  3; aLabyrinth[5, 6] := 14; aLabyrinth[6, 6] := 11; aLabyrinth[7, 6] :=  6; aLabyrinth[8, 6] := 10; aLabyrinth[9, 6] := 10; aLabyrinth[10, 6] :=  0;
  aLabyrinth[1, 5] :=  5; aLabyrinth[2, 5] :=  7; aLabyrinth[3, 5] := 15; aLabyrinth[4, 5] :=  5; aLabyrinth[5, 5] :=  7; aLabyrinth[6, 5] :=  7; aLabyrinth[7, 5] :=  5; aLabyrinth[8, 5] := 15; aLabyrinth[9, 5] :=  7; aLabyrinth[10, 5] :=  5;
  aLabyrinth[1, 4] :=  0; aLabyrinth[2, 4] :=  9; aLabyrinth[3, 4] :=  7; aLabyrinth[4, 4] := 12; aLabyrinth[5, 4] :=  3; aLabyrinth[6, 4] :=  6; aLabyrinth[7, 4] :=  9; aLabyrinth[8, 4] :=  7; aLabyrinth[9, 4] := 12; aLabyrinth[10, 4] :=  0;
  aLabyrinth[1, 3] :=  5; aLabyrinth[2, 3] := 15; aLabyrinth[3, 3] :=  5; aLabyrinth[4, 3] := 15; aLabyrinth[5, 3] := 12; aLabyrinth[6, 3] :=  9; aLabyrinth[7, 3] := 15; aLabyrinth[8, 3] :=  5; aLabyrinth[9, 3] := 15; aLabyrinth[10, 3] :=  5;
  aLabyrinth[1, 2] :=  0; aLabyrinth[2, 2] := 11; aLabyrinth[3, 2] :=  5; aLabyrinth[4, 2] :=  6; aLabyrinth[5, 2] := 11; aLabyrinth[6, 2] := 14; aLabyrinth[7, 2] :=  3; aLabyrinth[8, 2] :=  5; aLabyrinth[9, 2] := 14; aLabyrinth[10, 2] :=  0;
  aLabyrinth[1, 1] :=  0; aLabyrinth[2, 1] :=  3; aLabyrinth[3, 1] :=  5; aLabyrinth[4, 1] :=  5; aLabyrinth[5, 1] :=  6; aLabyrinth[6, 1] :=  3; aLabyrinth[7, 1] :=  5; aLabyrinth[8, 1] :=  5; aLabyrinth[9, 1] :=  6; aLabyrinth[10, 1] :=  0;

  // registry keys management
  iReg := TregIniFile.Create(REG_KEY);                                          // system registry init

{}// init graphics
{}bFullscreenMode := iReg.ReadBool('', 'FullscreenMode', true);
{}pm_10_fullscreen.Checked := bFullscreenMode;
{}Gfxinit.Gfx_Game_Init;
{}bGameMenuOpen := false;

{}// initialises the "hints" array
  for i := 1 to 10 do
    aKeyHints[i] := '''' + Chr(i + 47) + '''';

  for i := 11 to 36 do
    aKeyHints[i] := '''' + Chr(i + 54) + '''';

  aKeyHints[37] := '''up arrow'' key';
  aKeyHints[38] := '''down arrow'' key';
  aKeyHints[39] := '''left arrow'' key';
  aKeyHints[40] := '''right arrow'' key';
  aKeyHints[41] := '''alt'' key';
  aKeyHints[42] := '''ctrl'' key';
  aKeyHints[43] := '''shift'' key';
  aKeyHints[44] := '''spacebar''';

  // reads values from system registry into the inputs array
  aKeys[1].int := iReg.ReadInteger('', 'Key1', 2);                              // "Power On/Off" (default: "1")
  aKeys[2].int := iReg.ReadInteger('', 'Key2', 3);                              // "Select"       (default: "2")
  aKeys[3].int := iReg.ReadInteger('', 'Key3', 4);                              // "Start"        (default: "3")
  aKeys[4].int := iReg.ReadInteger('', 'Key4', 37);                             // "Up"           (default: "UP")
  aKeys[5].int := iReg.ReadInteger('', 'Key5', 39);                             // "Left"         (default: "LEFT")
  aKeys[6].int := iReg.ReadInteger('', 'Key6', 40);                             // "Right"        (default: "RIGHT")
  aKeys[7].int := iReg.ReadInteger('', 'Key7', 38);                             // "Down"         (default: "DOWN")

  // writes values into the system registry (in case no pre-existing values
  // stored), then assigns key values to the key-inputs array
  for i := 1 to NUM_KEYS do
    begin
      iReg.WriteInteger('', 'Key' + inttostr(i), aKeys[i].int);
      KeysForm.AssignWord(i, aKeys[i].int);
    end;

  // sets button images hints
  btn_power_top.Hint           := HINT_CLICK + ' ' + aKeyHints[aKeys[1].int] + ' ' + HINT_POWER_OFF; // "Click to turn game on"
  btn_select_top.Hint          := HINT_CLICK + ' ' + aKeyHints[aKeys[2].int] + ' ' + HINT_SELECT;    // "Select"
  btn_start_top.Hint           := HINT_CLICK + ' ' + aKeyHints[aKeys[3].int] + ' ' + HINT_START;     // "Start"

  btn_joystick_top.Hint        := HINT_JOYSTICK + ' ' + aKeyHints[aKeys[4].int] + ', ' // "Up"
                                                      + aKeyHints[aKeys[5].int] + ', ' // "Left"
                                                      + aKeyHints[aKeys[6].int] + ', ' // "Right"
                                                      + aKeyHints[aKeys[7].int];       // "Down"

  btn_ctrlr_overlay_up.Hint    := HINT_CLICK + ' ' + aKeyHints[aKeys[4].int];   // "Up"
  btn_ctrlr_overlay_left.Hint  := HINT_CLICK + ' ' + aKeyHints[aKeys[5].int];   // "Left"
  btn_ctrlr_overlay_right.Hint := HINT_CLICK + ' ' + aKeyHints[aKeys[6].int];   // "Right"
  btn_ctrlr_overlay_down.Hint  := HINT_CLICK + ' ' + aKeyHints[aKeys[7].int];   // "Down"

  // popup menu array association
  aMenuItem[1]  := pm_1_about;
  aMenuItem[2]  := pm_2_readme;
  aMenuItem[3]  := pm_3_whatsnew;
  aMenuItem[4]  := pm_4_manual;
  aMenuItem[5]  := pm_5_n1;
  aMenuItem[6]  := pm_6_config;
  aMenuItem[7]  := pm_7_keys;
  aMenuItem[8]  := pm_9_n2;
{}aMenuItem[9] := pm_10_fullscreen;
{}aMenuItem[10] := pm_11_splashscreen;
{}aMenuItem[11] := pm_12_controller;
{}aMenuItem[12] := pm_13_n3;
{}aMenuItem[13] := pm_14_exit;

  // controller overlay setting
{}pm_12_controller.Checked  := iReg.ReadBool('', 'CtrlrOverlay', true);
{}bDisplayCtrlOverlays := pm_12_controller.Checked;

  // controller overlay
  Vid_Display_Ctrl_Overlay;

  // variables init

  DoubleBuffered := true;                                                       // enables double buffering rendering

  bRightArrowKeyPressed := false;                                               // right arrow key is not currently being kept pressed
  bUpArrowKeyPressed    := false;                                               // up    arrow key is not currently being kept pressed
  bLeftArrowKeyPressed  := false;                                               // left  arrow key is not currently being kept pressed
  bDownArrowKeyPressed  := false;                                               // down  arrow key is not currently being kept pressed

  Randomize;                                                                    // initializes the random number generator
end;





procedure TForm1.FormActivate(Sender: TObject);
{ sends focus to the splash screen at startup                                  }
begin
  if bStartup then
    begin
      bStartup := false;
      SplashForm.Show;
    end;
end;





procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
{ frees memory before shutting down                                            }
begin
  FSOUND_Sample_Free(pfs_bonus); FSOUND_Sample_Free(pfs_energiz);
  FSOUND_Sample_Free(pfs_ghost); FSOUND_Sample_Free(pfs_miss);
  FSOUND_Sample_Free(pfs_pill);  FSOUND_Sample_Free(pfs_pill_alt);
  FSOUND_Sample_Free(pfs_stage); FSOUND_Sample_Free(pfs_start);

  FSOUND_Close;

{}iReg.Destroy;
  Action := caFree;
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: DISPLAY MANAGEMENT                                           * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.Vid_Display_Ctrl_Overlay;
{ displays or hides the controller overlay images                              }
begin
  btn_ctrlr_overlay_up.Visible    := bDisplayCtrlOverlays;
  btn_ctrlr_overlay_left.Visible  := bDisplayCtrlOverlays;
  btn_ctrlr_overlay_right.Visible := bDisplayCtrlOverlays;
  btn_ctrlr_overlay_down.Visible  := bDisplayCtrlOverlays;

  btn_joystick_top.Visible := (not bDisplayCtrlOverlays);
end;





procedure TForm1.Vid_Display_All_Sprites(b: boolean);
{ displays/hides all sprites, incl. score panel                                }
  var
    i : integer;
begin
  for i := 1 to 5 do
    aIm_panel_score[i].Visible := b;

  i := Ord(b) * 2; Vid_Display_Panel_Life(i);

  im_panel_gameover.Visible := b;

  Vid_Display_All_Chewy(b);
  Vid_Display_All_Pill(b);
  Vid_Display_All_Ghost(b);
end;





procedure TForm1.Vid_Display_All_Chewy(b: boolean);
{ displays/hides all Chewy sprites                                             }
  var
    i, j: integer;
begin
  for i := 2 to 9 do
    for j := 1 to 7 do
      if not ( ((j = 4) and (i = 5)) or ((j = 4) and (i = 6)) ) then
        aIm_chewy[i, j].Visible := b;
end;





procedure TForm1.Vid_Display_All_Ghost(b: boolean);
{ displays/hides all ghosts                                                    }
  var
    i, j: integer;
begin
  for i := 2 to 9 do
    for j := 1 to 7 do
      aIm_ghost[i, j].Visible := b;
end;





procedure TForm1.Vid_Display_All_Pill(b: boolean);
{ displays/hides all pills, energizers and bonus stars                         }
  var
    i, j: integer;
begin
  for i := 2 to 9 do
    for j := 1 to 7 do
      if not ( ((j = 4) and (i = 5)) or ((j = 4) and (i = 6)) ) then
        aIm_pill[i, j].Visible := b;
end;





procedure TForm1.Vid_Display_Chewy(var p, q: integer; b: boolean);
{ displays/hides Chewy in 'p, q' position                                      }
begin
  if (p >= 2) and (p <= 9) and not ((p = 5) and (q = 4)) and not ((p = 6) and (q = 4)) then
    aIm_Chewy[p, q].Visible := b;
end;





procedure TForm1.Vid_Display_Ghost(var p: integer; b: boolean);
{ displays/hides Ghost n. 'p' except when he's in tunnels                      }
begin
  if (aGhost[p].iPosX >= 2) and (aGhost[p].iPosX <= 9) then
    aIm_Ghost[aGhost[p].iPosX, aGhost[p].iPosY].Visible := b;
end;





procedure TForm1.Vid_Display_Panel_Life(var p: integer);
{ displays/hides lives left (1 to 2)                                           }
  var
    i: integer;
begin
  for i := 1 to 2 do
    aIm_panel_lives[i].Visible := p >= i;
end;





procedure TForm1.Vid_Display_Panel_Score(var p: integer; b: boolean);
{ transforms scoreinto sprites, and displays/hides them                        }
  var
    i, t: integer;
begin
  t := p;

  while t >= 100000 do                                                          // prevents displayed score from being above 99990
    Dec(p, 100000);

  if b then                                                                     // display or hide score/high-score?
    begin                                                                         // display
      aIm_panel_score[1].Picture := aIm_panel_numbers[t div 10000 mod 10].Picture; // tens of thousands
      aIm_panel_score[2].Picture := aIm_panel_numbers[t div  1000 mod 10].Picture; // thousands
      aIm_panel_score[3].Picture := aIm_panel_numbers[t div   100 mod 10].Picture; // hundreds
      aIm_panel_score[4].Picture := aIm_panel_numbers[t div    10 mod 10].Picture; // tens
      aIm_panel_score[5].Picture := aIm_panel_numbers[t           mod 10].Picture; // units
    end
  else                                                                            // hide
    for i := 1 to 5 do
      aIm_panel_score[i].Picture := nil;

  for i := 1 to 5 do
    aIm_panel_score[i].Visible := true;
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: AUDIO MANAGEMENT                                             * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.Snd_Play(pfs: PFSoundSample);
{ plays a certain sound sample                                                 }
begin
  if bSound then
    FSOUND_PlaySound(FSOUND_FREE, pfs);
end;





procedure TForm1.Snd_Silence;
{ stops any currently playing sound sample                                     }
begin
  if bSound then
    FSOUND_StopSound(FSOUND_ALL);
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: INPUT MANAGEMENT - EVENTS                                    * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.im_backgroundMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ dragging the main form: PRESS                                                }
{ Note: this routine works if the game is not in 'Fullscreen' mode only        }
begin
{}if (not bFullscreenMode)
    and (Button = mbLeft) then
    begin
      iMouseX := X;
      iMouseY := Y;
    end;
end;





procedure TForm1.im_backgroundMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
{ dragging the main form: MOVE                                                 }
{ Note: this routine works if the game is not in 'Fullscreen' mode only        }
begin
{}if (not bFullscreenMode)
    and (ssLeft in Shift) then
    begin
      Top  := Top  + Y - iMouseY;
      Left := Left + X - iMouseX;
    end;
end;





procedure TForm1.btn_power_topMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ on/off button: PRESS                                                         }
begin
  if Button = mbLeft then
    Inp_power_down;
end;





procedure TForm1.btn_select_topMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ select button: PRESS                                                         }
begin
  if Button = mbLeft then
    Inp_select_down;
end;





procedure TForm1.btn_select_topMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ select button: RELEASE                                                       }
begin
  if Button = mbLeft then
    Inp_select_up;
end;





procedure TForm1.btn_start_topMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ start button: PRESS                                                          }
begin
  if Button = mbLeft then
    Inp_start_down;
end;





procedure TForm1.btn_start_topMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ start button: RELEASE                                                        }
begin
  if Button = mbLeft then
    Inp_start_up;
end;





procedure TForm1.btn_ctrlr_overlay_upMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ up button: PRESS                                                             }
begin
  if Button = mbLeft then
    Inp_arrow_up_down;
end;



procedure TForm1.btn_ctrlr_overlay_upMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ up button: RELEASE                                                           }
begin
  if Button = mbLeft then
    Inp_arrow_up_up;
end;





procedure TForm1.btn_ctrlr_overlay_leftMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ left button: PRESS                                                           }
begin
  if Button = mbLeft then
    Inp_arrow_left_down;
end;





procedure TForm1.btn_ctrlr_overlay_leftMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ left button: RELEASE                                                         }
begin
  if Button = mbLeft then
    Inp_arrow_left_up;
end;





procedure TForm1.btn_ctrlr_overlay_rightMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ right button: PRESS                                                          }
begin
  if Button = mbLeft then
    Inp_arrow_right_down;
end;





procedure TForm1.btn_ctrlr_overlay_rightMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ right button: RELEASE                                                        }
begin
  if Button = mbLeft then
    Inp_arrow_right_up;
end;





procedure TForm1.btn_ctrlr_overlay_downMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ down button: PRESS                                                           }
begin
  if Button = mbLeft then
    Inp_arrow_down_down;
end;





procedure TForm1.btn_ctrlr_overlay_downMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ down button: RELEASE                                                         }
begin
  if Button = mbLeft then
    Inp_arrow_down_up;
end;





procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
{ keypress: PRESS                                                              }
begin
  if Key = aKeys[1].word then Inp_power_down  else                              // Power On/Off
  if Key = aKeys[2].word then Inp_select_down else                              // Select Game A/B
  if Key = aKeys[3].word then Inp_start_down  else                              // Start

  if Key = aKeys[4].word then Inp_arrow_up_down     else                        // Up
  if Key = aKeys[5].word then Inp_arrow_left_down   else                        // Left
  if Key = aKeys[6].word then Inp_arrow_right_down  else                        // Right
  if Key = aKeys[7].word then Inp_arrow_down_down;                              // Down
end;





procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
{ keypress: RELEASE                                                            }
begin
  if Key = aKeys[2].word then Inp_select_up else                                // Select Game A/B
  if Key = aKeys[3].word then Inp_start_up  else                                // Start

  if Key = aKeys[4].word then Inp_arrow_up_up     else                          // Up
  if Key = aKeys[5].word then Inp_arrow_left_up   else                          // Left
  if Key = aKeys[6].word then Inp_arrow_right_up  else                          // Right
  if Key = aKeys[7].word then Inp_arrow_down_up;                                // Down
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: INPUT MANAGEMENT - ACTIONS                                   * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.Inp_power_down;
{ power button: PRESS                                                          }
begin
  // sets game mode
  if iMode = 0 then                                                             // tabletop off
    begin
      iMode := 1; Gam_Set_Mode;                                                 // tabletop is on in Demo mode
      btn_power_top.Hint := HINT_CLICK + ' ' + aKeyHints[aKeys[1].int] + ' ' + HINT_POWER_ON; // "click to turn off"
    end
  else                                                                          // else
    begin
      iMode := 0; Gam_Set_Mode;                                                 // whatever mode -> tabletop off
      btn_power_top.Hint := HINT_CLICK + ' ' + aKeyHints[aKeys[1].int] + ' ' + HINT_POWER_OFF // "click to turn on"
    end;

  btn_power_on.Visible := (iMode = 1);
end;





procedure TForm1.Inp_select_down;
{ select button: PRESS                                                         }
begin
  btn_select_down.Visible := true;

  // sets game mode
  case iMode of
    2:      begin iMode := 3; Gam_Set_Mode; end;                                // Demo 2/2      -> Select Game 1
    3:      begin iMode := 4; Gam_Set_Mode; end;                                // Select Game 1 -> Select Game 2
    4:      begin iMode := 5; Gam_Set_Mode; end;                                // Select Game 2 -> Select Game 3
    5:      begin iMode := 6; Gam_Set_Mode; end;                                // Select Game 3 -> Select Game 4
    6:      begin iMode := 3; Gam_Set_Mode; end;                                // Select Game 4 -> Select Game 1
    11..14: begin iMode := 3; Gam_Set_Mode; end;                                // Game Over 1-4 -> Select Game 1
  end; // case..of
end;





procedure TForm1.Inp_select_up;
{ select button: RELEASE                                                       }
begin
  btn_select_down.Visible := false;
end;





procedure TForm1.Inp_start_down;
{ start button: PRESS                                                          }
begin
  btn_start_down.Visible := true;

  // sets game mode
  if (iMode >= 3) and (iMode <= 6) then                                         // if mode is "Select Game x"
    begin
      Inc(iMode, 4);                                                              // sets "Game Start x"
      Gam_Set_Mode;
    end;

  // sets game mode
  if (iMode >= 11) and (iMode <= 14) then                                       // if mode is "Game Over x"
    begin
      Dec(iMode, 4);                                                              // sets "Game Start x"
      Gam_Set_Mode;
    end;
end;





procedure TForm1.Inp_start_up;
{ start button: RELEASE                                                        }
begin
  btn_start_down.Visible := false;
end;





procedure TForm1.Inp_arrow_right_down;
{ arrow right key: PRESS                                                       }
begin
  bRightArrowKeyPressed := true;
end;





procedure TForm1.Inp_arrow_right_up;
{ arrow right key: RELEASE                                                     }
begin
  bRightArrowKeyPressed := false;
end;





procedure TForm1.Inp_arrow_up_down;
{ arrow up key: PRESS                                                          }
begin
  bUpArrowKeyPressed := true;
end;





procedure TForm1.Inp_arrow_up_up;
{ arrow up key: RELEASE                                                        }
begin
  bUpArrowKeyPressed := false;
end;





procedure TForm1.Inp_arrow_left_down;
{ arrow left key: PRESS                                                        }
begin
  bLeftArrowKeyPressed := true;
end;





procedure TForm1.Inp_arrow_left_up;
{ arrow left key: RELEASE                                                      }
begin
  bLeftArrowKeyPressed := false;
end;




procedure TForm1.Inp_arrow_down_down;
{ arrow down key: PRESS                                                        }
begin
  bDownArrowKeyPressed := true;
end;





procedure TForm1.Inp_arrow_down_up;
{ arrow up key: RELEASE                                                        }
begin
  bDownArrowKeyPressed := false;
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: GAME ROUTINES                                                * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.Gam_Stop_All_Timers;
{ stops all timers at once                                                     }
begin
  Timer_Bonus_Star.Enabled     := false;
  Timer_Demo_Start.Enabled     := false;
  Timer_Game.Enabled           := false;
  Timer_Miss.Enabled           := false;
  Timer_Stage_Complete.Enabled := false;
end;





procedure TForm1.Gam_Set_Mode;
{ sets game/time/alarm/ACL mode, depending on the value of the iMode variable  }
  var
    i, j: integer;
begin
  case iMode of
    0: begin                                                                    // OFF
         Gam_Stop_All_Timers;                                                           // stops action
         Snd_Silence;                                                                   // stops playing sounds

         Vid_Display_All_Sprites(false);                                                // hides all sprites
         im_background_screen.Visible := false;                                         // hides lcd screen background
       end;
    1: begin                                                                    // DEMO 1
         Gam_Stop_All_Timers;                                                           // stops action
         Snd_Silence;                                                                   // stops playing sounds

         Vid_Display_All_Sprites(false);                                                // hides all sprites
         i := 0; Vid_Display_Panel_Score(i, true);                                      // displays '00000' on score panel
         im_background_screen.Visible := true;                                          // displays lcd screen background

         Snd_Play(pfs_start);                                                           // plays "Start" tune

         Timer_Demo_Start.Interval := 2980;                                             // sets "Start" tune duration
         Timer_Demo_Start.Enabled := true;                                              // sets mode to Demo 2/2
       end;
    2: begin end;                                                               // DEMO 2
    3, 4, 5, 6: begin                                                           // SELECT GAME 1 - 4
         Vid_Display_All_Sprites(false);                                                // hides all sprites
         i := 0; Vid_Display_Panel_Score(i, false);                                     // displays blank panel score sprites
         aIm_panel_score[1].Picture := aIm_panel_numbers[iMode - 2].Picture;            // displays '1-4' on score panel
       end;

    7, 8, 9, 10: begin                                                          // GAME 1 - 4
         im_panel_gameover.Visible := false;
         Gam_Init_Game;
       end;
    11, 12, 13, 14: begin                                                       // GAME OVER 1 - 4
         // does nothing...
       end;
  end; // case..of
end;





procedure TForm1.Gam_Init_Stage_Chewy;
{ inits Chewy coordinates for a new stage/game reprise after miss              }
begin
  // sets Chewy position and direction
  iChewyPosX      := 6;
  iChewyPosY      := 3;
  iChewyDirection := 0;

  // sets Chewy mode to "escape"
  iLoopGameEnergizer := 0;

  // displays Chewy
  Vid_Display_All_Chewy(false);
  Vid_Display_Chewy(iChewyPosX, iChewyPosY, true);
end;





procedure TForm1.Gam_Init_Stage_Ghosts;
{ inits amounts of active ghosts and their coordinates for a new stage/game    }
{ reprise after miss                                                           }
  var
    i: integer;
begin
  // sets amount of ghosts on stage, and their speed
  case iMode of
    7: begin                                                                    // Game 1
         iGhostSpeed := 5;                                                        // slow on every stage

         if iStage = 1 then iGhostsOnStage := 1                                   // 1 ghost on stage 1
         else               iGhostsOnStage := 2;                                  // 2 ghosts on stage 2+
       end;
    8: begin                                                                    // Game 2
         iGhostSpeed := 5;                                                        // slow on every stage

         if iStage = 1 then   iGhostsOnStage := 1                                 // 1 ghost on stage 1
         else
           if iStage = 2 then iGhostsOnStage := 2                                 // 2 ghosts on stage 2
           else               iGhostsOnStage := 3;                                // 3 ghosts on stage 3+
       end;
    9: begin                                                                    // Game 3
         if iStage < 3 then   iGhostSpeed := 5                                    // slow on stages 1 and 2
         else                 iGhostSpeed := 2;                                   // fast on stages 3, etc.

         if iStage = 1 then   iGhostsOnStage := 1                                 // 1 ghost on stage 1
         else
           if iStage = 2 then iGhostsOnStage := 2                                 // 2 ghosts on stage 2
           else               iGhostsOnStage := 3;                                // 3 ghosts on stage 3+
       end;
   10: begin                                                                    // Game 4
         iGhostSpeed := 2;                                                        // fast on every stage

         if iStage = 1 then   iGhostsOnStage := 2                                 // 2 ghosts on stage 1
         else                 iGhostsOnStage := 3;                                // 3 ghosts on stage 2+
       end;
  end; // case..of

  // sets active/inactive ghosts and their position
  for i := 1 to 3 do
    aGhost[i].iStatus := Ord(i <= iGhostsOnStage); // 0 or 1

  aGhost[1].iPosX := 5; aGhost[1].iPosY := 4; // (5,4)
  aGhost[2].iPosX := 6; aGhost[2].iPosY := 4; // (6,4)
  aGhost[3].iPosX := 6; aGhost[3].iPosY := 4; // (6,4)

  // displays ghosts
  Vid_Display_All_Ghost(false);

  for i := 1 to iGhostsOnStage do
    Vid_Display_Ghost(i, true);
end;





procedure TForm1.Gam_Init_Stage_Labyrinth;
{ inits labyrinth for a new stage                                              }
  var
    i, j: integer;
begin
  // sets pills array
  for i := 2 to 9 do
    for j := 1 to 4 do
      aPill[i, j * 2 - 1] := 1;                                                 // sets to 1 for all cells in odd rows except the ones where energizers and Bonus Stars are

  for i := 2 to 9 do
    for j := 1 to 3 do
      if (i <> 3) and (i <> 8) then aPill[i, j * 2] := 1;                       // sets to 1 for all cells in even rows, except columns 3 and 8

  aPill[3, 2] := 2; aPill[8, 2] := 2; aPill[3, 6] := 2; aPill[8, 6] := 2;       // energizers on
  aPill[5, 4] := 0; aPill[6, 4] := 0;                                           // no pills in ghosts pit
  aPill[1, 3] := 0; aPill[1, 5] := 0; aPill[10, 3] := 0; aPill[10, 5] := 0;     // no pills in tunnels

  // sets Bonus Stars on/off
  Gam_Set_Bonus_Stars;

  // sets "pills-to-go" variable
  iPillsToGo := 52;

  // displays pills (columns 1 and 10 excluded)
  for i := 2 to 9 do
    for j := 1 to 7 do
      if not ( ((j = 4) and (i = 5)) or ((j = 4) and (i = 6)) ) then
        aIm_pill[i, j].Visible := aPill[i, j] <> 0;
end;





procedure TForm1.Gam_Init_Game;
{ inits game variables for the very beginning of the game (score, lives left,  }
{ current stage, etc.)                                                         }
begin
  iScore     := 0; Vid_Display_Panel_Score(iScore, true);
  iLivesLeft := 2; Vid_Display_Panel_Life(iLivesLeft);
  iStage     := 1;
  iScoreNextBonusLife := 20000;

  // no problems with displaying/hiding Bonus Stars
  iScoreLastBonusStar := -10;

  // inits stage (Chewy, pills, ghosts, etc.)
  Gam_Init_Stage_Chewy;
  Gam_Init_Stage_Ghosts;
  Gam_Init_Stage_Labyrinth;

  // forces Bonus Stars on screen, and iLoopGameBonusStar at "2 * CHEWY_SPEED" game tick
  aPill[3, 4]            := 3;     aPill[8, 4]            := 3;
  aIm_pill[3, 4].Visible := true;  aIm_pill[8, 4].Visible := true;
  iLoopGameBonusStar := 1 * CHEWY_SPEED;

  // loops action
  Gam_Start_Stage;
end;





procedure TForm1.Gam_Set_Bonus_Stars;
{ displays/hides Bonus Stars                                                   }
{ display:  at every 30 * CHEWY_SPEED Timer_Game ticks AND Chewy scored at     }
{           least 1 point after eating the previous Bonus Star                 }
{ hide:     at every 30 * CHEWY_SPEED                                          }
{ duration: 6 * CHEWY_SPEED on, and 24 * CHEWY_SPEED off                       }
begin
  // displays new Bonus Stars if iLoopGameBonusStar = 1, and Chewy scored a few
  // points since absorbing the previous Bonus Star
  if (iLoopGameBonusStar = 1) and (iScore <> iScoreLastBonusStar) then
    begin
      aPill[3, 4]            := 3;     aPill[8, 4]            := 3;
      aIm_pill[3, 4].Visible := true;  aIm_pill[8, 4].Visible := true;
    end;

  // hides Bonus Stars if iLoopGameBonusStar = BONUS_STAR_ON * CHEWY_SPEED
  // (lasts BONUS_STAR_OFF * CHEWY_SPEED Timer_Game ticks)
  if iLoopGameBonusStar = BONUS_STAR_ON * CHEWY_SPEED then
    begin
      aPill[3, 4]            := 0;     aPill[8, 4]            := 0;
      aIm_pill[3, 4].Visible := false; aIm_pill[8, 4].Visible := false;
    end;
end;





procedure TForm1.Gam_Start_Stage;
{ sets "iLoop" variables and Timer_Game starts ticking...                      }
begin
  iLoopGame := 1;
  Timer_Game.Interval := 120;
  Timer_Game.Enabled := true;
end;




procedure TForm1.Gam_Move_Ghosts;
{ moves ghosts                                                                 }
  var
    i, p,
    iAllowedDirs,
    iGhostDir    : integer;
begin
  for i := 1 to iGhostsOnStage do
    begin
      iAllowedDirs := aLabyrinth[aGhost[i].iPosX, aGhost[i].iPosY];
      iGhostDir := 0;

      if aGhost[i].iStatus = 1 then
        begin
          if (aGhost[i].iPosY = 5) and (iChewyPosY = 5) then
            // ghost and Chewy on row 5
            begin
              p := aGhost[i].iPosX - iChewyPosX;

              if (p >= -9) and (p <= -5) then iGhostDir := 4 else                 // ghost on left, close to Chewy
              if (p >= -4) and (p <= -1) then iGhostDir := 1 else                 // ghost on left, far from Chewy
              if (p = 0)                 then iGhostDir := 0 else                 // ghost and Chewy on the same cell
              if (p >= 1)  and (p <= 4)  then iGhostDir := 4 else                 // ghost on right, close to Chewy
              if (p >= 5)  and (p <= 9)  then iGhostDir := 1;                     // ghost on right, far from Chewy
            end  // (aGhost[i].iPosY = 5) and (iChewyPosY = 5)
          else
            // ghost and Chewy on row 3
            if (aGhost[i].iPosY = 3) and (iChewyPosY = 3) then
              begin
                if (aGhost[i].iPosX <= 5) and (iChewyPosX >= 6) then iGhostDir := 4 else // opposite sides (1)
                if (aGhost[i].iPosX >= 6) and (iChewyPosX <= 5) then iGhostDir := 1 else // opposite sides (2)
                  begin                                                                  // same side
                    if aGhost[i].iPosX - iChewyPosX > 0 then iGhostDir := 4 else         // ghost on right than Chewy
                    if aGhost[i].iPosX - iChewyPosX < 0 then iGhostDir := 1 else         // ghost on left  than Chewy
                                                             iGhostDir := 0;             // ghost and Chewy on the same cell
                  end;
              end  // (aGhost[i].iPosY = 3) and (iChewyPosY = 3)
            else
              // whichever else row, or any column -> prevents from moving far from Chewy
              begin
                if (aGhost[i].iPosY = iChewyPosY) then
                  begin
                    if (aGhost[i].iPosX < iChewyPosX) and ((iAllowedDirs and 4) = 4) then Dec(iAllowedDirs, 4) else
                    if (aGhost[i].iPosX > iChewyPosX) and ((iAllowedDirs and 1) = 1) then Dec(iAllowedDirs, 4);
                  end
                else
                  if (aGhost[i].iPosX = iChewyPosX) then
                    begin
                      if (aGhost[i].iPosY < iChewyPosY) and ((iAllowedDirs and 8) = 8) then Dec(iAllowedDirs, 8) else
                      if (aGhost[i].iPosY > iChewyPosY) and ((iAllowedDirs and 2) = 2) then Dec(iAllowedDirs, 2);
                    end;
              end;

        end // aGhost[i].iStatus = 1
      else
        // escaping ghost -> prevents from moving towards Chewy (except when in corridor -> random direction)
        begin
          if (aGhost[i].iPosY = iChewyPosY) and (aGhost[i].iPosX < iChewyPosX) and (aGhost[1].iPosX <> 1) and (aGhost[1].iPosX <> 10) and ((iAllowedDirs and 1) = 1) then Dec(iAllowedDirs, 1) else
          if (aGhost[i].iPosY = iChewyPosY) and (aGhost[i].iPosX > iChewyPosX) and (aGhost[1].iPosX <> 1) and (aGhost[1].iPosX <> 10) and ((iAllowedDirs and 4) = 4) then Dec(iAllowedDirs, 4) else
          if (aGhost[i].iPosX = iChewyPosX) and (aGhost[i].iPosY < iChewyPosY) and ((iAllowedDirs and 2) = 2) then Dec(iAllowedDirs, 2) else
          if (aGhost[i].iPosX = iChewyPosX) and (aGhost[i].iPosY > iChewyPosY) and ((iAllowedDirs and 8) = 8) then Dec(iAllowedDirs, 8);
        end;

      // if direction was not set before, move randomly

      // set which direction ghost moves
      if iGhostDir = 0 then
        repeat
          iGhostDir := Trunc(Power(2, Random(4)));                              // random 1/2/4/8

          if (iAllowedDirs and iGhostDir) <> iGhostDir                          // if iGhostDir is no good
            then iGhostDir := 0;                                                  // try random 1/2/4/8 again...
        until
          iGhostDir <> 0;

      // execute ghost move
      case iGhostDir of
        1: Inc(aGhost[i].iPosX);
        2: Inc(aGhost[i].iPosY);
        4: Dec(aGhost[i].iPosX);
        8: Dec(aGhost[i].iPosY);
      end; // case..of

      // coordinates inside tunnels
      if aGhost[i].iPosX = 11 then aGhost[i].iPosX := 1;                        // right corridors
      if aGhost[i].iPosX = 0  then aGhost[i].iPosX := 10;                       // left corridors
    end; // for i := 1 to iGhostsOnStage do
end;





function TForm1.Gam_Check_Chasing_Ghost: boolean;
{ returns "true" in case a chasing ghost has eaten Chewy                       }
  var
    i: integer;
begin
  Gam_Check_Chasing_Ghost := false;

  for i := 1 to iGhostsOnStage do
    if (iChewyPosX >= 2) and (iChewyPosX <= 9)
      and (aGhost[i].iPosX = iChewyPosX)
      and (aGhost[i].iPosY = iChewyPosY)
      and (aGhost[i].iStatus = 1)
    then
      Gam_Check_Chasing_Ghost := true;
end;




function TForm1.Gam_Check_Escaping_Ghost: boolean;
{ returns "true" in case an escape ghost was absorbed by Chewy                 }
  var
    i: integer;
begin
  Gam_Check_Escaping_Ghost := false;

  for i := 1 to iGhostsOnStage do
    if (iChewyPosX >= 2) and (iChewyPosX <= 9)
      and (aGhost[i].iPosX = iChewyPosX)
      and (aGhost[i].iPosY = iChewyPosY)
      and (aGhost[i].iStatus = 2)
    then
      Gam_Check_Escaping_Ghost := true;
end;





procedure TForm1.Gam_Check_New_Life;
{ adds new life at every 20000 points, unless iLivesLeft = 2                   }
begin
  if (iScore >= iScoreNextBonusLife) and (iLivesLeft < 2) then
    begin
      Inc(iLivesLeft);                                                          // adds new life in case iLivesLeft < 2
      Vid_Display_Panel_Life(iLivesLeft);
      Inc(iScoreNextBonusLife, 20000);                                          // sets score for next bonus life
    end;
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: TIMERS                                                       * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.Timer_Bonus_StarTimer(Sender: TObject);
{ Chewy absorbed a bonus star (plays sound, then game reprises)                }
begin
  case iLoopBonusStar of
    1: begin
         Snd_Play(pfs_bonus);

         Timer_Bonus_Star.Interval := 1000;
       end;
    2: begin
         Timer_Game.Enabled := true;
         Timer_Bonus_Star.Enabled := false;
       end;
  end; // case..of

  Inc(iLoopBonusStar);
end;





procedure TForm1.Timer_Demo_StartTimer(Sender: TObject);
{ sets iMode to 2 (Demo 2/2) after pf_start has played                         }
begin
  iMode := 2; Gam_Set_Mode;                                                     // sets mode to Demo 2/2

  Timer_Demo_Start.Enabled := false;
end;





procedure TForm1.Timer_GameTimer(Sender: TObject);
{ main game action                                                             }
  var
    i           : integer;
    bMissGhost,                                                                 // true if any miss occured
    bGotGhost,                                                                  // true if any escaping ghost has been absorbed
    bNoLoop,                                                                    // true if action has to stop
    bChewyMoved : boolean;
    pfTemp      : PFSoundSample;
begin
  bMissGhost := false;                                                          // no miss occured yet
  bGotGhost  := false;                                                          // no escaping ghost absorbed yet
  bNoLoop    := false;                                                          // enables action loop for next tick by now

  pfTemp  := nil;

  // sets sound sample to "energiz" by now, to play in case any ghost is in
  // "escaping" status
  for i := 1 to iGhostsOnStage do
    if aGhost[i].iStatus = 2 then
      pfTemp := pfs_energiz;

  // loops Bonus Star appear/disappear
  Inc(iLoopGameBonusStar);

  if iLoopGameBonusStar = (BONUS_STAR_ON + BONUS_STAR_OFF) * CHEWY_SPEED + 1 then
    iLoopGameBonusStar := 1;

  Gam_Set_Bonus_Stars;

  // ghosts movements and collision checks
  if iLoopGame mod iGhostSpeed = 0 then
    begin
      // ghosts move (on 1 tick out of iGhostSpeed)
      Gam_Move_Ghosts;

      // checks for collision between chasing ghosts and Chewy
      bMissGhost := Gam_Check_Chasing_Ghost;

      // checks for collision between escaping ghosts and Chewy
      bGotGhost := Gam_Check_Escaping_Ghost;
    end;

  // renders ghosts (on every game tick); ghost is rendered if:
  // a) he chases Chewy, on every tick;
  // b) he escapes Chewy, on half the CHEWY_SPEED time
  Vid_Display_All_Ghost(false);
  for i := 1 to iGhostsOnStage do
    Vid_Display_Ghost(i, ( (iLoopGame mod CHEWY_SPEED + 1) < CHEWY_SPEED div 2)
                           or Odd(aGhost[i].iStatus) );

  // Chewy moves (on 1 tick out of CHEWY_SPEED)
  if (not bMissGhost) and (not bGotGhost) and (iLoopGame mod CHEWY_SPEED = 0) then
    begin
      bChewyMoved := false;

      if bRightArrowKeyPressed and ((aLabyrinth[iChewyPosX, iChewyPosY] and 1) = 1) then
        begin Inc(iChewyPosX); bChewyMoved := true; end                         // Chewy moves right
      else
        if bUpArrowKeyPressed and ((aLabyrinth[iChewyPosX, iChewyPosY] and 2) = 2) then
          begin Inc(iChewyPosY); bChewyMoved := true; end                       // Chewy moves up
        else
          if bLeftArrowKeyPressed and ((aLabyrinth[iChewyPosX, iChewyPosY] and 4) = 4) then
            begin Dec(iChewyPosX); bChewyMoved := true; end                     // Chewy moves left
          else
            if bDownArrowKeyPressed and ((aLabyrinth[iChewyPosX, iChewyPosY] and 8) = 8) then
              begin Dec(iChewyPosY); bChewyMoved := true; end;                  // Chewy moves down

      // coordinates inside tunnels
      if iChewyPosX = 11 then iChewyPosX := 1;                                  // right corridors
      if iChewyPosX = 0  then iChewyPosX := 10;                                 // left corridors

      // has Chewy moved or did he stand still?
      if bChewyMoved then
        begin
          // renders Chewy
          Vid_Display_All_Chewy(false);

          if (iChewyPosX >= 2) and (iChewyPosX <= 9) then
            Vid_Display_Chewy(iChewyPosX, iChewyPosY, true);

          // checks for collision between chasing ghosts and Chewy
          bMissGhost := Gam_Check_Chasing_Ghost;

          if not bMissGhost then
            begin
              // Chewy eating pill (10 points, "pill" or "pill_alt" sample plays)
              if aPill[iChewyPosX, iChewyPosY] = 1 then
                begin
                  aPill[iChewyPosX, iChewyPosY] := 0;
                  aIm_pill[iChewyPosX, iChewyPosY].Visible := false;
                  Dec(iPillsToGo);
                  Inc(iScore, 10); Vid_Display_Panel_Score(iScore, true);

                  // 1st choice for sound tune to play: "pill"
                  pfTemp := pfs_pill;

                  // if any ghost is escaping, sound tune to play is "pill_alt"
                  for i := 1 to iGhostsOnStage do
                    if aGhost[i].iStatus = 2 then
                      pfTemp := pfs_pill_alt;
                end;

              // Chewy eating energizer (no score, no sound sample plays)
              if aPill[iChewyPosX, iChewyPosY] = 2 then
                begin
                  aPill[iChewyPosX, iChewyPosY] := 0;
                  aIm_pill[iChewyPosX, iChewyPosY].Visible := false;
                  Dec(iPillsToGo);

                  for i := 1 to iGhostsOnStage do                               // sets ghosts in "escape" mode
                    aGhost[i].iStatus := 2;

                  iLoopGameEnergizer := 1;
                end;

              // checks for collision between escaping ghosts and Chewy
              bGotGhost := Gam_Check_Escaping_Ghost;

              // empty labyrinth
              if iPillsToGo = 0 then
                begin
                  Gam_Stop_All_Timers;

                  bNoLoop := true;

                  iLoopStageComplete := 1;
                  Timer_Stage_Complete.Interval := 1;
                  Timer_Stage_Complete.Enabled := true;
                end;
            end; // not bMiss
        end; // bChewyMoved

        if not bMissGhost then
          begin
            // Chewy eating a Bonus Star (2000 points, "bonus" sample plays)
            // (regardless of the fact that Chewy moved or not)
            if aPill[iChewyPosX, iChewyPosY] = 3 then
              begin
                Gam_Stop_All_Timers;

                aPill[iChewyPosX, iChewyPosY] := 0;
                aIm_pill[iChewyPosX, iChewyPosY].Visible := false;
                Inc(iScore, 2000); Vid_Display_Panel_Score(iScore, true);

                // prevents new Bonus Stars from appearing unless Chewy scores more points
                iScoreLastBonusStar := iScore;

                bNoLoop := true;

                iLoopBonusStar := 1;
                Timer_Bonus_Star.Interval := 1;
                Timer_Bonus_Star.Enabled := true;
              end;
          end; // not bMiss

        // checks score for "new bonus life"
        // (regardless of the fact that Chewy moved or not)
        Gam_Check_New_Life;
    end; // (not bMiss) and (iLoopGame mod CHEWY_SPEED = 0)

  // if a miss occured (stops action, plays "miss" sound tune, subtracts a life,
  // etc.)
  if bMissGhost then
    begin
      Gam_Stop_All_Timers;

      bNoLoop := true;

      iLoopMiss := 1;
      Timer_Miss.Interval := 1;
      Timer_Miss.Enabled := true;
    end;

  // if an escaping ghost has been absorbed (stops action, plays "ghost" sound
  // tune, adds score, etc.)
  if (not bMissGhost) and bGotGhost then
    begin
      Gam_Stop_All_Timers;

      for i := 1 to iGhostsOnStage do Vid_Display_Ghost(i, true);

      bNoLoop := true;

      iLoopGhost := 1;
      Timer_Ghost.Interval := 1;
      Timer_Ghost.Enabled := true
    end;

  // if no miss occured (plays sound sample, loops action, etc.)
  if (not bMissGhost) and (not bGotGhost) and (not bNoLoop) then
    begin
      // plays sound sample if set
      if pfTemp <> nil then
        Snd_Play(pfTemp);

      // loops action
      Inc(iLoopGame);

      if iLoopGame = (CHEWY_SPEED * iGhostSpeed) + 1 then
        iLoopGame := 1;

      // loops energizer duration, eventually ceases its effects
      if iLoopGameEnergizer <> 0 then
        Inc(iLoopGameEnergizer);

      if iLoopGameEnergizer > ENERGIZER_DURATION * CHEWY_SPEED then
        begin
          iLoopGameEnergizer := 0;

          for i := 1 to iGhostsOnStage do                                       // sets ghosts in "chasing" mode
            aGhost[i].iStatus := 1;
        end;
    end;
end;





procedure TForm1.Timer_GhostTimer(Sender: TObject);
{ Chewy caught an escaping ghost (increase score, plays sound, then game       }
{ action reprises                                                              }
  var
    i: integer;
begin
  case iLoopGhost of
    1: begin
         for i := 1 to iGhostsOnStage do
           if (aGhost[i].iPosX = iChewyPosX) and (aGhost[i].iPosY = iChewyPosY) then
             Vid_Display_Ghost(i, true);

         Timer_Ghost.Interval := 50;
       end;
    2: begin
         Snd_Play(pfs_ghost);

         Timer_Ghost.Interval := 600;
       end;
    3: begin
         for i := 1 to iGhostsOnStage do
           if (aGhost[i].iPosX = iChewyPosX) and (aGhost[i].iPosY = iChewyPosY) then
             begin
               Inc(iScore, 200); Vid_Display_Panel_Score(iScore, true);
               Gam_Check_New_Life;

               Vid_Display_Ghost(i, false);
               aGhost[i].iStatus := 1;
               aGhost[i].iPosX := 5;
               aGhost[i].iPosY := 4;
               Vid_Display_Ghost(i, true);
             end;

         Timer_Game.Enabled := true;

         Timer_Ghost.Enabled := false;
       end;
  end; // case..of

  Inc(iLoopGhost);
end;





procedure TForm1.Timer_MissTimer(Sender: TObject);
{ a ghost caught Chewy (decreases lives left, then game action reprises/ends   }
begin
  case iLoopMiss of
    1: Timer_Miss.Interval := 200;
    2: begin
         Snd_Play(pfs_miss);

         Timer_Miss.Interval := 600;
       end;
    3: begin
         Dec(iLivesLeft);
         Vid_Display_Panel_Life(iLivesLeft);

         Vid_Display_Chewy(iChewyPosX, iChewyPosY, false);
         Gam_Init_Stage_Chewy;                                                  // resets Chewy position

         Vid_Display_All_Ghost(false);
         Gam_Init_Stage_Ghosts;                                                 // resets ghosts positions

         // any lives left? yes -> game reprises, or no -> game over
         if iLivesLeft >= 0 then
           begin                                                                // game reprises
             iLoopGame := 1;
             Timer_Game.Enabled := true;

             Timer_Miss.Enabled := false;
           end
         else
           begin                                                                // plays "Game Start" tune, then game over at next tick
             Snd_Play(pfs_start);
             Gam_Init_Stage_Labyrinth;                                          // displays all labyrinth again
             im_panel_gameover.Visible := true;

             Timer_Miss.Interval := 2980;
           end;
       end;
    4: begin                                                                    // goes into "Game Over" mode
         Inc(iMode, 4);

         Timer_Miss.Enabled := false;
       end;
  end; // case..of

  Inc(iLoopMiss);
end;





procedure TForm1.Timer_Stage_CompleteTimer(Sender: TObject);
{ stage was cleared (initializes a new maze)                                   }
begin
  case iLoopStageComplete of
    1: Timer_Stage_Complete.Interval := 200;
    2: begin
         Snd_Play(pfs_stage);
         Inc(iStage);
         Gam_Init_Stage_Chewy;
         Gam_Init_Stage_Ghosts;
         Gam_Init_Stage_Labyrinth;

         Timer_Stage_Complete.Interval := 3200;
       end;
    3: begin
         Gam_Start_Stage;

         Timer_Stage_Complete.Enabled := false;
       end;
  end; // case..of

  Inc(iLoopStageComplete);
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: POPUP MENU MANAGEMENT                                        * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.pm_0_menuPopup(Sender: TObject);
{ shows the "checked" menuitems if needed. also, hides the game menu if it is  }
{ visible when the popup menu pops up                                          }
begin
{}pm_11_splashscreen.Checked := iReg.ReadBool('', 'SplashScreen', SplashForm.chb_splashscreen.Checked);
{}pm_12_controller.Checked := bDisplayCtrlOverlays;

{}if bFullscreenMode
    and bGameMenuOpen then
    begin
      bGameMenuOpen := false;
      Vid_Display_Game_Menu(bGameMenuOpen);
    end;
end;





procedure TForm1.pm_1_aboutClick(Sender: TObject);
{ displays the embedded "About the author..." form                             }
begin
  AboutForm.Show;
end;





procedure TForm1.pm_2_readmeClick(Sender: TObject);
{ opens the "Readme.txt" file                                                  }
begin
  ShellExecute(Handle, 'open', 'Readme.txt', nil, '', SW_SHOWNORMAL);
end;





procedure TForm1.pm_3_whatsnewClick(Sender: TObject);
{ opens the "Whatsnew.txt" file                                                }
begin
  ShellExecute(Handle, 'open', 'Whatsnew.txt', nil, '', SW_SHOWNORMAL);
end;





procedure TForm1.pm_4_manualClick(Sender: TObject);
{ displays the embedded instructions manual                                    }
begin
  // ManualForm.Show;
end;





procedure TForm1.pm_6_configClick(Sender: TObject);
{ opens the "Config.ini" file                                                  }
begin
  ShellExecute(Handle, 'open', 'Config.ini', nil, '', SW_SHOWNORMAL);
end;





procedure TForm1.pm_7_keysClick(Sender: TObject);
{ displays the "key settings" form                                             }
begin
  KeysForm.position := poScreenCenter;
  KeysForm.visible := true;
  Enabled := false;
end;





{}procedure TForm1.pm_10_fullscreenClick(Sender: TObject);
{ changes from fullscreen to windowed, and vice-versa                          }
begin
  // updates popup menu
  bFullscreenMode := not bFullscreenMode;
  pm_10_fullscreen.Checked := bFullscreenMode;
  bGameMenuOpen := false;

  iReg.WriteBool('', 'FullscreenMode', bFullscreenMode);

  // graphics init
  Top  := - Screen.Height;
  Left := - Screen.Width;
  Gfx_Game_Init;
  Position := poScreenCenter;
end;





procedure TForm1.pm_11_splashscreenClick(Sender: TObject);
{ updates the ticks to the checkbox, the popup menu and the system registry    }
begin
{}pm_11_splashscreen.Checked := not pm_11_splashscreen.Checked;

{}iReg.WriteBool('', 'SplashScreen', pm_11_splashscreen.Checked);
end;





procedure TForm1.pm_12_controllerClick(Sender: TObject);
{ displays the "tranlucent" controller overlay on the directional cross        }
begin
{}pm_12_controller.Checked := not pm_12_controller.Checked;
{}bDisplayCtrlOverlays := pm_12_controller.Checked;

{}iReg.WriteBool('', 'CtrlrOverlay', pm_12_controller.Checked);

  Vid_Display_Ctrl_Overlay;
end;





procedure TForm1.pm_14_exitClick(Sender: TObject);
{ exits the game                                                               }
begin
  Application.Terminate;
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: GAME MENU MANAGEMENT                                         * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.btn_game_menu_topClick(Sender: TObject);
{ sets the game menu as visible/hidden, then displays/hides it                 }
begin
  bGameMenuOpen := not bGameMenuOpen;
  Vid_Display_Game_Menu(bGameMenuOpen);
end;





procedure TForm1.la_menu_itemMouseEnter(Sender: TObject);
{ the game menu label bg colour becomes solid                                  }
begin
  if Sender is TLabel then
    TLabel(Sender).Transparent := false;
end;





procedure TForm1.la_menu_itemMouseLeave(Sender: TObject);
{ the game menu label bg colour becomes transparent                            }
begin
  if Sender is TLabel then
    TLabel(Sender).Transparent := true;
end;





procedure TForm1.la_menu_itemMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ hides the game menu, once a label has been pressed                           }
begin
  if Button = mbLeft then
    begin
      bGameMenuOpen := false;
      Vid_Display_Game_Menu(false);
    end;
end;





procedure TForm1.Vid_Display_Game_Menu(b: boolean);
{ displays/hides the game menu, depending on the value of bGameMenuOpen        }
  var
    i: integer;
begin
  case bGameMenuOpen of
    true: begin
        for i := 1 to MENU_ITEMS do
          begin
            aMenuLabels[i] := TLabel.Create(Form1);
            aMenuLabels[i].Parent := Form1;

            aMenuLabels[i].Top := 32 * i;
            aMenuLabels[i].Left := 0;

            aMenuLabels[i].AutoSize := false;
            aMenuLabels[i].Height := 32;
            aMenuLabels[i].Width := 256;
            aMenuLabels[i].Layout := tlCenter;

            aMenuLabels[i].Transparent := true;

            if aMenuItem[i].Caption <> '-' then
              begin
                aMenuLabels[i].Font.Name := 'Arial';
                aMenuLabels[i].Font.Color := clWhite;
                aMenuLabels[i].Font.Size := -12;
                aMenuLabels[i].Caption := '   ' + aMenuItem[i].Caption;

                if aMenuItem[i].Checked then
                  aMenuLabels[i].Caption := aMenuLabels[i].Caption + ' [V]';

                aMenuLabels[i].Color := $00000000;
                aMenuLabels[i].Cursor := crHandPoint;
                aMenuLabels[i].Enabled := aMenuItem[i].Enabled;

                if aMenuLabels[i].Enabled then
                  begin
                    aMenuLabels[i].OnClick      := aMenuItem[i].OnClick;
                    aMenuLabels[i].OnMouseEnter := la_menu_itemMouseEnter;
                    aMenuLabels[i].OnMouseLeave := la_menu_itemMouseLeave;
                    aMenuLabels[i].OnMouseUp    := la_menu_itemMouseUp;
                  end;
              end;
          end;

        btn_game_menu_background.Width := 256;
        btn_game_menu_background.Height := 32 * (MENU_ITEMS + 1)
      end;
    false: begin
        for i := 1 to MENU_ITEMS do
          begin
            aMenuLabels[i].Free;
          end;

        btn_game_menu_background.Height := 32;
        btn_game_menu_background.Width := 36;
      end;
    end; // case..of
end;





initialization
  bStartup := true;





end.
